<?xml version="1.0" encoding="ISO-8859-1"?><!DOCTYPE rss PUBLIC "-//Netscape Communications//DTD RSS 0.91//EN" "http://my.netscape.com/publish/formats/rss-0.91.dtd">
<rss version="0.91"><channel><title>Apache FOP (1.1) Changes</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Apache FOP
              (
              1.1
              ) Changes
            </description><language>en-us</language>

  
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
  

  
    
    
    
    
    
    
    
    
    
    
  

  
    
    
      <item><title>Apache FOP Test fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Test fix
        by
        GA
        :
        
        Fix errors and warnings in example files. Add build.xml for documentation examples.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 53458)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53458)
        
        :
        
        Fix incorrect language and country code key generation in hyphenation tree cache.
       Thanks to Dieter von Holten.</description></item>
      <item><title>Apache FOP Images fix
          (bug 53431)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images fix
        by
        GA
          (fixes bug 53431)
        
        :
        
        Fix incorrect SVG line dash pattern with PDF output format.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Images update
          (bug 40676)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images update
        by
        GA
          (fixes bug 40676)
        
        :
        
        Fix interoperability issue with Adobe reader regarding use of multiple filters.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
        :
        
        Eliminate javadocs warnings.
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 52338)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        VH
          (fixes bug 52338)
        
        :
        
        Added possibility to embed TrueType fonts in PostScript.
      </description></item>
      <item><title>Apache FOP Images update
          (bug 40676)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images update
        by
        GA
          (fixes bug 40676)
        
        :
        
        Update site documentation about PNG image loading configuration and support.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Images update
          (bug 40676)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images update
        by
        GA
          (fixes bug 40676)
        
        :
        
        Fix newly introduced findbugs warnings.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Images fix
          (bug 40676)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images fix
        by
        GA
          (fixes bug 40676)
        
        :
        
        Support use of ImageLoaderRawPNG decoder in order to prevent re-encoding of PNG images (and unnecssary output file bloat).
       Thanks to Luis Bernardo, Matthias Reischenbacher.</description></item>
      <item><title>Apache FOP Code fix
          (bug 53412)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53412)
        
        :
        
        Eliminate incorrect use of object identity which produces excessive property cache collisions.
       Thanks to Alexios Giotis.</description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
        :
        
        Eliminate javadocs warnings.
      </description></item>
      <item><title>Apache FOP Code update
          (bug 53055)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        GA
          (fixes bug 53055)
        
        :
        
        Update xmlgraphics common jar to reflect recent fixes in XGC.
      </description></item>
      <item><title>Apache FOP Code update
          (bug 43940)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        GA
          (fixes bug 43940)
        
        :
        
        Fix handling of NaN, {+,-}Infinity, and other edge cases. Submitted by Julien Aymé.
       Thanks to Julien Aymé.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 53304,53306)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 53304,53306)
        
        :
        
        Add version attribute to AT and IF intermediate formats. Also eliminate redundant use of reversed attribute in AT format.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 53295)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 53295)
        
        :
        
        Add extension to place code just before PostScript %PageTrailer.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 53294)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 53294)
        
        :
        
        Fix invalid PostScript file being created when font-size is 0.
       Thanks to Robert Meyer.</description></item>
      <item><title>Apache FOP Docs update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Docs update
        by
        GA
        :
        
        Update FAQ and New Bug documentation.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
        :
        
        Added support for the role property on fo:page-sequence, fo:flow and fo:static-content. This 
        allows to change the mapping of those FOs to PDF structure types when enabling 
        accessibility.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        VH
        :
        
        Stop outputting the Type entry for structure elements in order to create a smaller PDF 
        ouptut when accessibility is enabled.
       Thanks to Martin Koegler.</description></item>
      <item><title>Apache FOP Config fix
          (bug 52144)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Config fix
        by
        GA
          (fixes bug 52144)
        
        :
        
        Fix crash on use of version switch (-v).
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 53242)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 53242)
        
        :
        
        Support fractional line widths in AFP renderer, fixing problem with SVG line drawing.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Config fix
          (bug 53248)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Config fix
        by
        GA
          (fixes bug 53248)
        
        :
        
        Fix exception thrown from use of -print option in CLI.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Docs fix
          (bug 53247)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Docs fix
        by
        GA
          (fixes bug 53247)
        
        :
        
        Fix renderer mime type for PCL output; should be application/x-pcl.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 40699)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 40699)
        
        :
        
        Fix for invalid PDF for certain numerical values in SVG lineargradient.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 53185)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 53185)
        
        :
        
        Unify date formatting between FOP and XGC as well as tidying the date format code.
       Thanks to Robert Meyer.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 45715)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 45715)
        
        :
        
        Fix for break before (break-before) not respected on blocks nested in inlines.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 48723)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 48723)
        
        :
        
        Fix for XGC when rendering PostScript using SVG being drawn upside down when using a custom affine transform.
       Thanks to Robert Meyer.</description></item>
      
      <item><title>Apache FOP Code fix
          (bug 43940)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 43940)
        
        :
        
        Use new double format utility to improve thread safety and performance.
       Thanks to Ognjen Blagojevic.</description></item>
      <item><title>Apache FOP Fonts fix
          (bug 53148)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        GA
          (fixes bug 53148)
        
        :
        
        Fix performance regression in JDK 1.6 Update 19 due to use of Java Beans API. Fix checkstyle errors.
       Thanks to Tassos Charoulis.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 51484)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 51484)
        
        :
        
        Don't write final /sect suffix in RTF if section is last section.
       Thanks to Benjamin Riefenstahl.</description></item>
      <item><title>Apache FOP Fonts fix
          (bug 53143)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        GA
          (fixes bug 53143)
        
        :
        
        Ensure fonts are not loaded twice (redundantly).
      </description></item>
      <item><title>Apache FOP Test update
          (bug 50196)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Test update
        by
        GA
          (fixes bug 50196)
        
        :
        
        Add test for basic-link with padding.
       Thanks to Matthias Reischenbacher.</description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        GA
        :
        
        Improve property function argument parsing, specifically, better separate required, optional, and variable arguments and the handling of optional argument defaults.
        Regularize property function class names.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 51043)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 51043)
        
        :
        
        Don't restart layout unless abs(ipd difference) &gt; 1 in order to prevent rounding issues from triggering false restart.
       Thanks to Pascal Sancho.</description></item>
      <item><title>Apache FOP Fonts update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts update
        by
        GA
        :
        
        Removing experimental feature that violates XSL-FO and Unicode semantics by misinterpreting Basic Latin code points. Users must use private use codepoints to access font specific
        character mappings that have no assigned Unicode code point. See bug 50492.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 53103)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 53103)
        
        :
        
        Ensure that table cell spanning works in right-to-left writing mode.
       Thanks to Matthias Reischenbacher.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 53086)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 53086)
        
        :
        
        Ensure that table footer and header are included in bididirectional resolution.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 53097)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 53097)
        
        :
        
        Ensure writing-mode specified on fo:table is used to determine writing mode of table and its descendants.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 53094)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53094)
        
        :
        
        Convert block container overflow exception to event model, improving overflow property behavior.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Code update
          (bug 51617)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        GA
          (fixes bug 51617)
        
        :
        
        Add run target for embedded examples. Add increased JVM memory heap flag for example8 in case font cache is rebuilt.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 53083)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53083)
        
        :
        
        Update to use of checkstyle-5.5 as default configuration. Remove checkstyle-4.0 configuration. Also, import environment build properties before local properties, so that latter can refer to former.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 52572)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 52572)
        
        :
        
        Prevent NPE on use of unsupported collapse-with-precedence; fall back to collapse. Fix checkstyle errors from prior commit.
       Thanks to Pascal Sancho.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 52514)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 52514)
        
        :
        
        Ensure square image is appropriately scaled.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Code fix
          (bug 50062)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 50062)
        
        :
        
        Invoke JVM in headless mode from FOP command scripts and JS shell to prevent stealing focus from GUI applications.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 52114)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 52114)
        
        :
        
        Take leading derived space before/after into account when computing rows for TXT renderer.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 49893)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
          (fixes bug 49893)
        
        :
        
        A global setting to wrap F11 images in page segments.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 52763)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 52763)
        
        :
        
        Support list-block in marker, thus preventing NPE.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
        :
        
        Must use unqualified (local name) when reporting invalid child error.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 53065)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53065)
        
        :
        
        Restore lookup on Event message lookup field part. Add locale field to Event to
        enable locale dependent deferred bundle load during lookup field part substitution.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MH
        :
        
        Bug in AFP font metrics that performed integer arithmetic when it should have been
	double arithemetic.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 49754)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 49754)
        
        :
        
        Bring clone() in line with the recommendations in Object.clone().
       Thanks to Simon Pepping.</description></item>
      <item><title>Apache FOP Code fix
          (bug 52966)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 52966)
        
        :
        
        How to use native text with EPSDocumentGraphics2D.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Code fix
          (bug 51599)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51599)
        
        :
        
        Allow https scheme URI for PDF external action target.
       Thanks to Paul Huemer.</description></item>
      <item><title>Apache FOP Code fix
          (bug 50901)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 50901)
        
        :
        
        RTF percentage table column width not calculated from table.
       Thanks to Carsten Pfeiffer.</description></item>
      <item><title>Apache FOP Code fix
          (bug 51009)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51009)
        
        :
        
        RTF generates unexpected lines for blocks in tables. Also fix three findbugs issues.
       Thanks to Max Aster.</description></item>
      <item><title>Apache FOP Code fix
          (bug 51007)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51007)
        
        :
        
        RTF tables do not support percent column-widths.
       Thanks to Max Aster.</description></item>
      <item><title>Apache FOP Code fix
          (bug 50435)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 50435)
        
        :
        
        Access denied (java.util.PropertyPermission org.apache.fop.fo.properties.use-cache read).
       Thanks to Armin Haaf.</description></item>
      <item><title>Apache FOP Code fix
          (bug 49763)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 49763)
        
        :
        
        Incorrect message when encountering a block in an inline in a footnote.
       Thanks to Adrian Buza.</description></item>
      <item><title>Apache FOP Code fix
          (bug 47380)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 47380)
        
        :
        
        Specified rule-thickness applies only when leader-pattern is rule, otherwise should use default thickness.
       Thanks to Georg Datterl.</description></item>
      <item><title>Apache FOP Code fix
          (bug 49302)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 49302)
        
        :
        
        Eliminate duplicate code.
       Thanks to Julien Aymé.</description></item>
      <item><title>Apache FOP Code fix
          (bug 49350)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 49350)
        
        :
        
        Correct coding error in AFPResourceLevel#equals.
       Thanks to Julien Aymé.</description></item>
      <item><title>Apache FOP Code fix
          (bug 51836)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51836)
        
        :
        
        Throw IFException instead of NPE if navigation target (page reference) doesn't exist.
       Thanks to Melanie Drake.</description></item>
      <item><title>Apache FOP Code fix
          (bug 51808)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51808)
        
        :
        
        Fixed memory waste in traits map.
       Thanks to Sergey Vladimirov.</description></item>
      <item><title>Apache FOP Code fix
          (bug 51807)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51807)
        
        :
        
        Fixed small memory waste in rowCells array construction.
       Thanks to Sergey Vladimirov.</description></item>
      <item><title>Apache FOP Code fix
          (bug 53005)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53005)
        
        :
        
        Fixed incorrect rejection of fo:wrapper inside fo:inline inside fo:footnote-body.
       Thanks to Alberto Simőes.</description></item>
      
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
        :
        
        Added support for PDF Object Streams. When accessibility is enabled and PDF version 1.5 
        selected, the structure tree will be stored in object streams in order to reduce the size of 
        the final PDF.
       Thanks to Peter Hancock.</description></item>
      <item><title>Apache FOP Code fix
          (bug 46962)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
          (fixes bug 46962)
        
        :
        
        Fixed deadlock in PropertyCache.
       Thanks to Alexios Giotis.</description></item>
      <item><title>Apache FOP Config add
          (bug 51385)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Config add
        by
        VH
          (fixes bug 51385)
        
        :
        
        Added configuration option to set the version of the output PDF document.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Code fix
          (bug 52849)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MH
          (fixes bug 52849)
        
        :
        
        Fixed bug that caused a configured and installed SVG font to be stroked,
        also added an event indicating when fonts are stroked.
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        PH
        :
        
        Fix of a bug introduced when merging ImproveAccessibility.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 50391)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
          (fixes bug 50391)
        
        :
        
          Improved support for empty flow-name mapping.
      </description></item>
      <item><title>Apache FOP Layout add
          (bug 32789, 49008, 49687)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        GA
          (fixes bug 32789, 49008, 49687)
        
        :
        
        Add support for complex scripts, including: full bidi support, support for advanced
        typographic tables, advanced support for number conversion.
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        GA
        :
        
        Add support for OpenType advanced typographic tables (GDEF, GSUB, GPOS).
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 52655)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
          (fixes bug 52655)
        
        :
        
        Fixed rendering of special glyphs when using single-byte encoding mode.
       Thanks to Luis Bernardo.</description></item>
      
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
        :
        
        Improvements of the Accessibility features.
       Thanks to Vincent Hennebert.</description></item>
      <item><title>Apache FOP Code add
          (bug 52416)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        CB
          (fixes bug 52416)
        
        :
        
        Suppress unnecessary "font not found warnings" when generating AFP with raster fonts 
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Code add
          (bug 51209)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        CB
          (fixes bug 51209)
        
        :
        
        SVG text in AFP creates miscoded GOCA text
       Thanks to Luis Bernardo.</description></item>
      <item><title>Apache FOP Code add
          (bug 50391)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        CB
          (fixes bug 50391)
        
        :
        
        Add support for different flow-name of fo:region-body in FOP
       Thanks to Peter Hancock.</description></item>
      <item><title>Apache FOP Code add
          (bug 51664)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        CB
          (fixes bug 51664)
        
        :
        
        Tagged PDF performance improvement plus tests
       Thanks to Mehdi Houshmand.</description></item>	
      <item><title>Apache FOP Code add
          (bug 52197)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        MH
          (fixes bug 52197)
        
        :
        
        Improved AdobeStandardEncoding support in AFM files for type1 fonts
      </description></item>
      <item><title>Apache FOP Code add
          (bug 52151)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
          (fixes bug 52151)
        
        :
        
        Added ant script to get JaCoCo code coverage.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Code add
          (bug 52136)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
          (fixes bug 52136)
        
        :
        
        Added to build file JUnit target that uses a regex to run all of the test cases. This 
        reduces the risk that some of them are omitted when building FOP.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Code add
          (bug 52089)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
          (fixes bug 52089)
        
        :
        
        Allow JPEG images to be embedded in an AFP document as is, without being decoded and 
        encoded.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Code add
          (bug 52010)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
          (fixes bug 52010)
        
        :
        
        Simplification of the build: Reduced code duplication and layout engine tests.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Various bugfixes to make PDFDocumentGraphics2D operational again.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 51962)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
          (fixes bug 51962)
        
        :
        
        Fix for when the last simple-page-master referenced in a page-sequence-master is not
        chosen when force-page-count=odd.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Code add
          (bug 51928)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
          (fixes bug 51928)
        
        :
        
        Upgraded all tests to JUnit 4.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Fonts fix
          (bug 48696)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        PH
          (fixes bug 48696)
        
        :
        
        Bugfix for color model in IOCA IDE structure parameter for 4- and 8-bit grayscale images.
        Revision 4.
      </description></item>
      <item><title>Apache FOP Fonts fix
          (bug 51760)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        PH
          (fixes bug 51760)
        
        :
        
        Changes the way PostScript handles Graphics2D images such that if the language is set to
        level 3, the image is stored as an embedded file which has no length limit.  Previously it
        was stored as an array which has a implementation limit of 65535 elements.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Fonts fix
          (bug 51759)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        PH
          (fixes bug 51759)
        
        :
        
        PDFFactory responsible for asdigning name to a subset font.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Fonts fix
          (bug 51530)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        PH
          (fixes bug 51530)
        
        :
        
        Improved support for EBCDIC encoded double byte fonts fo AFP.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Fonts fix
          (bug 51205)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        PH
          (fixes bug 51205)
        
        :
        
        Corrected typographical errors in AFPBase12FontCollection.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 48062)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        PH
          (fixes bug 48062)
        
        :
        
        Improved fix of a bug relating to PCL painter thread safetly.  Previous fix in rev 895012
        worked by synchronizing methods of a static instance of Java2DFontMetrics.  This fix uses a
        unique instance for per thread.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        PH
        :
        
        Fixed a bug in AFP where an ArrayOutofBoundsException is throwqn when embedding a Page 
        Segment.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        VH
        :
        
        Added support for 128bit encryption in PDF output.
       Thanks to Michael Rubin.</description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        PH
        :
        
        Fixed a bug in AFP where the object area axes of an Include Object was incorrectly set when 
        rotated by 180. </description></item>
      <item><title>Apache FOP Fonts fix
          (bug 51596)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 51596)
        
        :
        
        Fixed a bug in TTF subsetting where a composite glyph could get
        remapped more than once resulting in garbled character.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Fonts fix
          (bug 50605)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 50605)
        
        :
        
        Fixed a number of bugs concerning Type 1 and other single-byte fonts
        (glyph width mismatches and overlapping characters).
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed a multi-threading bug for SVG images included through svg:image inside SVG documents.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        PH
        :
        
        Added an IFDocumentHandler filter for triggering rendering events.  Created an Event that
        captures an end page event with the page number.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        VH
        :
        
        Fix for alternative text not working in tagged PDF for TIFF images.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 50909)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        PH
          (fixes bug 50909)
        
        :
        
        Fixed io exception in MODCAParser caused by the improper use of mark() and reset() on the
        MODCA data input stream.  Added unit test. </description></item>
      <item><title>Apache FOP Fonts fix
          (bug 51144)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 51144)
        
        :
        
        Removed invalid entries in ToUnicode table of CID subset fonts. 
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 50899)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 50899)
        
        :
        
        Fixed mapping of font weights between CSS values and TextAttribute.WEIGHT_*. 
       Thanks to Glenn Adams.</description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        AFP GOCA: fonts were not embedded from within AFPGraphics2D.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        AFP GOCA: Changed the way FOP fonts are selected based on Batik's GVT fonts to match
        the behaviour of PDF/PS output.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added option to place AFP NOPs right before the end of a named page group (page-sequence),
        rather than after the start.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added option for PostScript output to optimize for file size rather than quality.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        AFP GOCA: Added option to disable GOCA and to control text painting inside GOCA graphics.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        AFP GOCA: Work-around for InfoPrint's AFP implementation which seems to lose
        the character set state over Graphics Data (GAD) boundaries.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Bugfix for AFP GOCA segments: they were not properly marked as appended which could
        lead to graphics state changes in some implementations.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 51010)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 51010)
        
        :
        
        Bugzilla 51010: Bookmarks create useless lines in RTF 
       Thanks to Max Aster.</description></item>	
      <item><title>Apache FOP Renderers fix
          (bug 51008)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 51008)
        
        :
        
        Bugzilla 51008: page-number-citation-last does not work in RTF
       Thanks to Max Aster.</description></item>	
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        VH
        :
        
        Added id element to intermediate format to track the origin of content.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 50987)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AD
          (fixes bug 50987)
        
        :
        
        Bugzilla 50988: Fixed a NullPointerException in case a white-space fo:character was removed
        due to white-space handling.
       Thanks to Matthias Reischenbacher.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 50987)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AD
          (fixes bug 50987)
        
        :
        
        Bugzilla 50987: Fixed an issue in PDF output where a link was added to the parent tree 
        instead of the related structure element.
       Thanks to Martin Koegler.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 50986)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AD
          (fixes bug 50986)
        
        :
        
        Bugzilla 50986: Fixed an issue where invalid PDF page content was generated due to 
        incorrect ET/EMC sequences.
       Thanks to Martin Koegler.</description></item>
      <item><title>Apache FOP Code fix
          (bug 50593)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 50593)
        
        :
        
        Fixed regression introduced by Bugzilla 50593: bookmarks pointing to a non-existing
        internal destination should just trigger a warning.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 50965)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 50965)
        
        :
        
        Bugzilla 50965: Fixed a regression in BlockContainerLayoutManager where margins were
        no longer reset after forced breaks.
       Thanks to Martin Koegler.</description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Implemented non-standard behavior for basic-link areas, such that they take into account the 
        heights of their descendants areas.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Fix for keep-together does not apply to fo:table-cell.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Fix for keep-together on a table containing row-spanning cells that was not honored.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 50196)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 50196)
        
        :
        
        Fix forpadding-start ignored when table-header/footer is repeated.
       Thanks to Matthias Reischenbacher.</description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Increased maximum possible PDF size from 2GB to around 9GB (hard maximum imposed by the PDF specification).
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added support for CIE Lab colors (from XSL-FO 2.0 WD).
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 49403)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 49403)
        
        :
        
        Initial work on spot colors (aka named colors) for PDF output.
       Thanks to Patrick Jaromin.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 50705)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 50705)
        
        :
        
        Fix to preserve the order of AFP TLEs and NOPs as given in the XSL-FO document.
       Thanks to Mehdi Houshmand.</description></item>
      <item><title>Apache FOP Fonts add
          (bug 50699)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
          (fixes bug 50699)
        
        :
        
        Added support for lookup of alternative glyphs when additional single-byte encodings are
        used, ex. replacing "Omegagreek" by "Omega" and vice versa.
       Thanks to Alexandros Papadakis.</description></item>
      <item><title>Apache FOP Code add
          (bug 48334)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
          (fixes bug 48334)
        
        :
        
        Added support for resolution of relative URIs against a specified xml:base during
        property refinement.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Allow afp:no-operation to also appear under fo:page-sequence and fo:declarations.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 50635)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 50635)
        
        :
        
        Fix for issue in RenderPagesModel.checkPreparedPages() where the same page-sequence
        is potentially started multiple times.
       Thanks to Martin Koegler.</description></item>
      <item><title>Apache FOP Code fix
          (bug 50636)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 50636)
        
        :
        
        Fix for performance issue when adding pages, if the total number of pages
        is significantly large.
       Thanks to Martin Koegler.</description></item>
      <item><title>Apache FOP Code fix
          (bug 50626)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 50626)
        
        :
        
        Fix for performance issue when adding nodes, if the number of children
        is significantly large.
       Thanks to Martin Koegler.</description></item>
      <item><title>Apache FOP Config fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Config fix
        by
        SP
        :
        
	Fix for relative URIs in the configuration file (base, font-base, hyphenation-base) are evaluated relative to the base URI of the configuration file.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 49848)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 49848)
        
        :
        
        Fix for correct behavior of keep-together.within-line in case there are nested inlines
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 50471)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 50471)
        
        :
        
        Fix for avoid ArrayIndexOutOfBoundsException for codepoints without a linebreak class
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 48380)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 48380)
        
        :
        
        Fix for avoid ClassCastException when using fox:widow-content-limit
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 50089)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 50089)
        
        :
        
        Fix for content after forced break in block-container is not rendered.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 42034)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 42034)
        
        :
        
        Fixed adjustment of inline parent area for justified text containing a forward page reference.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 38264)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 38264)
        
        :
        
        Fixed behavior when combining hyphenation with preserved linefeeds or whitespace.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 49695)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
          (fixes bug 49695)
        
        :
        
        Replaced magic numbers with constants from UnitConv and GraphicsConstants.
       Thanks to Joshua Marquart.</description></item>
      <item><title>Apache FOP Renderers add
          (bug 42600)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 42600)
        
        :
        
        Added some support for break-before/-after for RTF output.
       Thanks to Max Aster.</description></item>
      <item><title>Apache FOP Renderers add
          (bug 49379)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 49379)
        
        :
        
        Added ability to embed an external AFP page segment resource file (AFP output only).
       Thanks to Peter Hancock.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 46360)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 46360)
        
        :
        
        Fixed a multi-threading issue when rendering SVG.
       Thanks to Alexios Giotis.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 49885)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 49885)
        
        :
        
        Fixed retrieval of available BPD for cases spanning columns and multiple pages with differing page masters.
      </description></item>
      <item><title>Apache FOP Renderers remove</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers remove
        by
        VH
        :
        
        Removed old Renderer implementations for those output formats that have a version based on 
        the new DocumentHandler architecture available (AFP, PCL, PDF, PS).
      </description></item>
      <item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        AC
        :
        
        Reinstated support for being able to specify a font cache filepath in the fop user configuration.
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        AC
        :
        
        Added convenience support for the flushing of the Fop font cache file from the command line.
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 44460)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 44460)
        
        :
        
        Added support for PDF File Attachments (Embedded Files).
       Thanks to Andrejus Chaliapinas.</description></item>
    
    
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        AFP Output: Fixed positioning of Java2D-based images (when GOCA is enabled).
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        AFP Output: Added enhanced dithering functionality for images that are converted to
        bi-level images.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        AFP Output: Fix for bitmap images inside an SVG or G2D graphic (printer errors) and
        positioning fix for bitmaps from G2D graphics.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 42306)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 42306)
        
        :
        
        Fix for AWT viewer to correctly track page numbers in continuous display mode.
       Thanks to Richard Wheeldon.</description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Bugfix for formatting of floating point numbers which could lead to invalid PDFs.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Added a save/restoreGraphicsState pair for the initial coordinate system in PDF output
        for easier post-processing.
      </description></item>
      <item><title>Apache FOP Images add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images add
        by
        JM
        :
        
        Added customization ability for the image loading framework from FOP's configuration file.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 48696)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 48696)
        
        :
        
        Bugfix for color model in IOCA IDE structure parameter for 4- and 8-bit grayscale images.
       Thanks to Peter Hancock.</description></item>
      <item><title>Apache FOP Renderers add
          (bug 48567)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 48567)
        
        :
        
        Initial support for CID-keyed double-byte fonts (Type 0) in AFP output.
       Thanks to Peter Hancock.</description></item>
	  <item><title>Apache FOP API add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>API add
        by
        SP
        :
        Added a command-line option '-catalog' to use a catalog resolver for the XML and XSLT files</description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        SP
        :
        Implement internal character classes if the hyphenation pattern file does not contain them</description></item>
      <item><title>Apache FOP Layout fix
          (bug 46486)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 46486)
        
        :
        
        Bugfix: having a special page-master for the last page caused loss of content when normal 
        blocks were mixed with blocks spanning all columns.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        VH
        :
        
        Added possibility to customize PDF tagging via the &#8216;role&#8217; property.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 48237)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 48237)
        
        :
        
        Bugfix: AFP Renderer: Respect image color settings for svg 
       Thanks to Peter Hancock.</description></item>	  
	  <item><title>Apache FOP Renderers fix
          (bug 48376)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 48376)
        
        :
        
        Bugfix: AFP Renderer: Page Overlays not generated when using Intermediate Format
       Thanks to Venkat Reddy.</description></item>	  
      <item><title>Apache FOP Renderers fix
          (bug 48456)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 48456)
        
        :
        
        Bugfix: AFP Renderer: Underline is incorrectly placed when reference-orientation != 0
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 48453)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 48453)
        
        :
        
        Bugfix: AFP Renderer: Page Segments not positioned correctly when reference-orientation != 0
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
        :
        
        Added support for TrueType fonts with symbol character maps (like "Wingdings" and "Symbol").
        Character for these fonts are usually found in the 0xF020 to 0xF0FF range
        (a Unicode private use area). 
      </description></item>
      <item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
        :
        
        Bugfix: Font selection fallbacks did not work in some cases (ex. bold+italic to normal)
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 48290)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 48290)
        
        :
        
        Bugfix: AFP Renderer: AttributeQualifier Triplet occurs before TLE Value.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 48048)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 48048)
        
        :
        
        Bugfix in AFP output: fixed flags in GOCA GBAR order.
       Thanks to D.W. Harks.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 48185)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        VH
          (fixes bug 48185)
        
        :
        
        Bugfix in AFP output: rounding error when computing the CMYK components of a color.
       Thanks to Harald G. Henne.</description></item>
      <item><title>Apache FOP Code fix
          (bug 48167)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
          (fixes bug 48167)
        
        :
        
        Bugfix: when #CMYK pseudo-profile was used in the rgb-icc() function, always the fallback 
        RGB colors were used instead.
       Thanks to Venkat Reddy.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 48082)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 48082)
        
        :
        
        Bugfix: value of conditional space not always taken into account in the calculation of a 
        table&#8217;s height.
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 46705)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM,VH
          (fixes bug 46705)
        
        :
        
        Added basic accessibility and Tagged PDF support. 
       Thanks to Jost Klopfstein.</description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added support for encoding CMYK bitmap images (IOCA FS45) and TIFF images as embedded objects.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AC
        :
        
        Added support for xmlfile and xsltfile parameters in FOP's Ant Task.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 47941)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AC
          (fixes bug 47941)
        
        :
        
        BugFix: Maintain valid AFP by providing TLE truncation on Attribute Value Triplet values that are greater than 250 chars in length.
      </description></item>
      <item><title>Apache FOP Fonts fix
          (bug 47711)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 47711)
        
        :
        
        Fixed generation of CIDSet object in PDF output.
       Thanks to Nicolas Peninguy.</description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Fixed handling of percentage values for provisional-label-separation.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 47835)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 47835)
        
        :
        
        Fixed handling of percentage values for provisional-distance-between-starts.
       Thanks to Jonathan Levinson.</description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        CB
        :
        
        Added support for positioning Page Overlays in AFP Output
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
        :
        
        Added support for specifying referenced fonts per renderer in addition to the general
        match list.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added support for creating thumbnails or preview bitmaps of fixed size for PNG and TIFF
        output.
      </description></item>
      <item><title>Apache FOP Extensions add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Extensions add
        by
        JM
        :
        
        Added support for the #CMYK pseudo-profile supported by some commercial XSL implementations
        on the rgb-icc() function.
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        VH
        :
        
        Added limited support for pages of different inline-progression-dimensions within a 
        page-sequence.
      </description></item>
      <item><title>Apache FOP Layout add
          (bug 46905)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        AD
          (fixes bug 46905)
        
        :
        
        Added basic implementation for column-keeps.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 47710)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 47710)
        
        :
        
        White-space handling in markers with inline-content throws a NullPointerException
        in some cases.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 47694)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 47694)
        
        :
        
        Dithered Background Shading can produce illegal AFP if objects are very small
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        CB
        :
        
        AFP Output: Added support for IMM Extension on fo:simple-page-master.
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 47311)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 47311)
        
        :
        
        Added an initial set of extensions for prepress support (fox:bleed, fox:crop-offset,
        fox:crop-box and fox:scale). This is currently supported only by PDF and Java2D renderers.
       Thanks to Peter Coppens.</description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        PCL Output: Added support for specifying the output bin.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        AFP Output: Added support for embedding external AFP form maps (form defs) using the
        afp:include-form-map extension.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        AFP Output: Added support for AFP font embedding. Note: this changes the default behaviour.
        Like with PDF and PS, all fonts are embedded by default unless matched in the
        "referenced-fonts" section in the configuration.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 47508)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AD
          (fixes bug 47508)
        
        :
        
        Bugfix: Error while writing TLE's attribute qualifier in the output.
       Thanks to Bharat Attaluri.</description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
        :
        
        Bugfix: support justified text in AFP Renderer (already working in AFP Painter)
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        AD
        :
        
        AFP Renderer Raster Fonts:
        
          added support for fractional font-sizes in the configuration.
          selection of the smaller font-size, in case two possible fallbacks have the
              same difference to a requested size.
        
      </description></item>
      <item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        CB
        :
        
        Bugfix: support PFM Files with no extent table.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 46960)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 46960)
        
        :
        
        Bugfix: previously retrieved markers were not cleared if the new marker was empty.
      </description></item>
      <item><title>Apache FOP Fonts fix
          (bug 47232)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        VH
          (fixes bug 47232)
        
        :
        
        Bugfix: for the last character of a Type1 font, always a width of 0 was returned.
       Thanks to Maxim Wirt.</description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
        :
        
        Changed meaning of &#8216;-v&#8217; option to &#8216;verbose&#8217;, which will print FOP&#8217;s version and proceed.
        Added a &#8216;-version&#8217; option to simply print the version then exit, following Java practices.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 47101)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 47101)
        
        :
        
        Bugfix: The cells of a table inside a marker were duplicated at every marker retrieval.
      </description></item>
      <item><title>Apache FOP Images fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images fix
        by
        JM
        :
        
        Bugfix: use the effective color profile supplied by the ImageEncodingHelper, instead of the
        original one.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Bugfix: reset graphic state when a page is finished in PostScript.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added setting to enable dithered painting of filled rectangles in AFP and PCL.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Bugfix: footnotes occurring within the forced height of a table row did not appear on the
        output
      </description></item>
      <item><title>Apache FOP Renderers update
          (bug 47031)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers update
        by
        JM
          (fixes bug 47031)
        
        :
        
        PDFGraphics2D.writeClip doesn't generate a clip command anymore when the clip path
        is empty.
       Thanks to Francois Fernandes.</description></item>
      <item><title>Apache FOP Renderers add
          (bug 47000)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 47000)
        
        :
        
        Added a custom text painter for rendering SVG text using text operators when rendering
        to PostScript or EPS. Text is no longer painted as shapes, thus creating much smaller files.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed a bug that left the PrintRenderer unconfigured even if a configuration was
        specified for "application/X-fop-print".
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 46882)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 46882)
        
        :
        
        Fixed the handling of CMYK colors in PDFGraphics2D.
       Thanks to Yegor Kozlov.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 46489)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 46489)
        
        :
        
        Fixed a bug when combining a forced break with a "last" page-master. The restart
        of the algorithm would start at the index of the penalty corresponding to the last
        page-break. This has been changed to the index of the first element after the last
        page-break.
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
        :
        
        Added a command-line tool to list all configured fonts
        (org.apache.fop.tools.fontlist.FontListMain).
      </description></item>
      <item><title>Apache FOP Code add
          (bug 46828)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
          (fixes bug 46828)
        
        :
        
        Added the possibility to use CachedRenderPagesModel, to conserve memory in case
        of large documents with a lot of cross-references (area tree will be serialized to
        disk to avoid keeping it entirely in memory).
       Thanks to Dario Laera.</description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
        :
        
        AFP Fonts: Added support for full URI resolution on configured AFP fonts.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        AFP Output: Tag Logical Element (TLE) is now also allowed on fo:page-sequence
        (page group level).
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
        :
        
        Fixed BPD trait and border painting for leaders with leader-pattern="space"
        (and similar cases).
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        AFP Output: Added support for Invoke Medium Map (IMM).
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Introduced a new, additional intermediate format optimized for performance. Please see
        the intermediate format documentation for details.
      </description></item>
      <item><title>Apache FOP Fonts fix
          (bug 46686)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 46686)
        
        :
        
        Use temporary directory for the font cache if the user home directory is not
        write-accessible.
       Thanks to Alok Singh.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 45342)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 45342)
        
        :
        
        AFP Fonts: Fixed interpretation of metric for fonts with fixed metrics and made sure
        all repeating groups in FNP (Font Position) are processed.
       Thanks to Emil Maskovsky.</description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        AFP Output: Added a configuration option to override the resource level defaults in the
        code.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 46638)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
          (fixes bug 46638)
        
        :
        
        MinOptMaxUtil.toMinOptMax was converting LengthRangeProperty objects into illegal MinOptMax
        objects (in some cases opt could be inferior to min).
      </description></item>
      <item><title>Apache FOP Layout add
          (bug 46315)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        VH
          (fixes bug 46315)
        
        :
        
        Added extension to disable column balancing before blocks spanning the whole page, in
        multiple-column documents.
       Thanks to Georg Datterl.</description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        AFP Output: Bilevel images in resource groups as generated as hard page segments
        (instead of image objects) for better interoperability with older IPDS environments
        and for better printing performance.
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
        :
        
        FOP now creates ToUnicode CMaps for single-byte fonts that don't use built-in
        encodings to help PDF text extractors interpreting characters.
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
        :
        
        Added support for forcing single-byte encodings for TrueType fonts without
        creating an XML font metric file (see "encoding-mode" attribute on "font" element)
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 45306)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 45306)
        
        :
        
        Fixed fo:instream-foreign-object inside fo:marker.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed black backgrounds occurring for transparent images in PCL output.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 46369)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 46369)
        
        :
        
        Fixed bug that caused AFP Renderer Extensions to be ignored.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 46319)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 46319)
        
        :
        
        Fixed a memory-leak in Marker.MarkerAttribute, where an instance was used both as key and value in
        a WeakHashMap, effectively neutralizing the benefit of using WeakReferences. Solved by extending
        PropertyCache to work for MarkerAttributes as well.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed a multi-threading issue when rendering SVG.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        AC
        :
        
        AFP Output: An AFPGraphics2D implementation which provides the ability to use Batik to drive the production of AFP Graphics (GOCA) output from SVG.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        AC
        :
        
        AFP Output: Resource group leveling, external streaming, and de-duplication of images and graphics using IncludeObject and ResourceGroup.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        AC
        :
        
        AFP Output: Native image embedding support (e.g. JPEG, GIF, TIFF) using ObjectContainer and a MOD:CA Registry implementation.
      </description></item>
      <item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        AC
        :
        
        More robust AFP font parsing, although it is still in need of some rework in the future.
      </description></item>
      <item><title>Apache FOP Images add
          (bug 41657)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images add
        by
        JM
          (fixes bug 41657)
        
        :
        
        Added support for SVG 1.2 functionality inside fo:instream-foreign-object.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 46240)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 46240)
        
        :
        
        Fixed a bug when combining break-before with a span change.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 46211)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 46211)
        
        :
        
        Fixed some multi-threading issues in FontCache.java:
        
        remove the unused private readObject()
        make the changeLock member final (initialization-safety + impossible to reassign)
        perform the HashMap check for a failed font inside the synchronized block to avoid a race condition
        
       Thanks to rogov.AT.devexperts.com.</description></item>
      <item><title>Apache FOP Renderers add
          (bug 45113)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        AD
          (fixes bug 45113)
        
        :
        
        Added PDF /Launch action: references to URIs using the file:// protocol will now generate
        a /Launch action as opposed to a more general /URI (which doesn't yield the expected result
        for this protocol).
       Thanks to Alexander Stamenov.</description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
        :
        
        Fixed a problem where the BPD or a block area could be wrong if there is a nested,
        absolutely positioned area (for example a block-container).
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 45971)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
          (fixes bug 45971)
        
        :
        
        Improved the behaviour of the command line interface.
       Thanks to Tow Browder.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 40798)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 40798)
        
        :
        
        Bugzilla 40798: A conditional-page-master-reference with page-position="last" qualifies
        for a first page, if it is also the last. Additionally: also added support for
        page-position="only".
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 45842)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 45842)
        
        :
        
        Make fop.bat and fop.cmd use the %FOP_OPTS% environment variable.
       Thanks to Carsten Siedentop.</description></item>
      <item><title>Apache FOP Renderers add
          (bug 45795)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 45795)
        
        :
        
        PDF Output: Added support for handling 16-bit alpha channel. They are currently
        converted to 8 bits.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        PDF Output: Made sure the XMP Metadata stream is never compressed.
      </description></item>
      <item><title>Apache FOP Fonts fix
          (bug 45734)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 45734)
        
        :
        
        Fix for PFMReader after bug #43089 changed the behavior of PFMFile. Fixes baseline
        problems when Type 1 fonts are used in conjunction with XML font metric files.
       Thanks to J. Frantzius.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 45616)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 45616)
        
        :
        
        Fix for table handling in RTF output, so the output works with OpenOffice and AbiWord, too.
       Thanks to Pavel Kysilka.</description></item>
      <item><title>Apache FOP Code fix
          (bug 45667)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 45667)
        
        :
        
        Quick-fix to avoid a possible NullPointerException when using
        empty inlines and hyphenation.
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        JM
        :
        
        Added missing generation of areas for empty grid units in tables with collapsing border
        model.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fixed memory leak in property cache (not cleaning stale PropertyCache$CacheEntry instances).
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed text stroking in SVG when the stroke-width is zero.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
        :
        
        Fixed the source for a division by zero when the content of an fo:leader with
        leader-pattern="use-content" collapses to zero width during layout.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed border trait parsing for the area tree XML when CMYK or ICC colors were used.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 45606)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 45606)
        
        :
        
        Fixed generation of "fonttbl" for RTF output to fix loading problem with AbiWord.
       Thanks to Pavel Kysilka.</description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
        :
        
        Fixed ID resolution for nested bookmarks with duplicated IDs.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 45490)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 45490)
        
        :
        
        Fixed a slight error when resolving non-file URLs: avoid
        altering the original 'href' if the protocol is other than 'file:'
       Thanks to Thomas Stieler.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 45470)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 45470)
        
        :
        
        Added LayoutManagerMapping.registerMaker() to make registration of custom
        layout managers easier.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        LF
        :
        
        Fixed absolute positioning of block-containers when specified
        using right and bottom instead of left and top.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        AC
        :
        
        Added PDF encryption parameter support in configuration.
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        LF
        :
        
        Allowing non-zero borders and padding on page regions when
        relaxed validation is turned on.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        LF
        :
        
        Fixed an inconsistency in footnote handling that led to unnecessary
        empty areas in pages whose last normal line contains footnotes
        when the page bpd is not the same for all pages.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        AD
        :
        
        Changed FONode.addCharacters() parameter to closer match the signature of
        the standard SAX characters() event (reduces confusion and computations).
        !! Implementors of extensions that subclass FONode directly, and
        offer an implementation for addCharacters() should take care to make
        similar modifications in their code !!
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 45115)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 45115)
        
        :
        
        Added a PCL-specific extension attribute on simple-page-master for controlling
        the simplex/duplex mode.
       Thanks to Martin Edge.</description></item>
      <item><title>Apache FOP Code fix
          (bug 45097)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 45097)
        
        :
        
        Corrected white-space-treatment for situations where an inline-node is the first/last
        child node of an fo:block, without preceding/following text.
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        MB
        :
        
        Implemented word-by-ford font-selection strategy on text.
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        MB
        :
        
        Support character-by-character font-selection strategy on fo:character element.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 44794)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 44794)
        
        :
        
        Added support for page-number-citation and page-number-citation-last
        of fo:inline. Corrected behavior for page-number-citation-last
        of fo:block: forward references now properly resolved.
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
        :
        
        For auto-detected fonts it is now possible to specify that a font needs to be referenced
        rather than embedded (for the output formats that support this distinction).
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 42423)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 42423)
        
        :
        
        Added support for the "id" attribute on fo:wrappers when used
        as a child of the fo:flow.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 41500)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 41500)
        
        :
        
        Fixed a ClassCastException when using an fo:wrapper as a child
        of an fo:block-container.
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        AC
        :
        
        Add support for font substitution.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 43650)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 43650)
        
        :
        
        PCL Renderer: Improved page format selection so it doesn't interfere with
        duplex printing.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 42703)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 42703)
        
        :
        
        Fixed a regression introduced by the fix for
        Bugzilla 44286.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 43591)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 43591)
        
        :
        
        Activated min-height/max-height and min-width/max-width properties.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 44203)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 44203)
        
        :
        
        Fixed a logic error in Hyphenator.java:
        If the source had an associated InputStream, an UnsupportedOperationException was
        triggered.
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 44634)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        AD
          (fixes bug 44634)
        
        :
        
        Add partial support for the "show-destination" property on fo:basic-link
        (PDF output only; see limitations on the compliance page)
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        JM
        :
        
        Added minimal support for integer keep values on the various keep properties on block-level
        FOs. For now, all integer values are treated the same (i.e. without strength distinction).
        Using integers allows to avoid overflows that can happen when "always" is used extensively.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added support for rendering pages using JPS (Java Printing System). See new example:
        examples/embedding/java/ExamplesFO2JPSPrint.java
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 41687)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 41687)
        
        :
        
        Restored ability to specify from/to and odd/even pages as well as the number of copies
        for printing from the command-line.
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 44678)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 44678)
        
        :
        
        Added ability to pass a preconfigured PrinterJob instance to the PrintRenderer via
        the rendering options map.
       Thanks to Antti Karanta.</description></item>
      <item><title>Apache FOP Renderers add
          (bug 44743)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 44743)
        
        :
        
        Added a public accessor for reference to the current page to PDFGraphics2D.
       Thanks to Yegor Kozlov.</description></item>
      <item><title>Apache FOP Fonts add
          (bug 44737)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
          (fixes bug 44737)
        
        :
        
        Added support for auto-configuring TrueType Collections. XML font metrics files for
        *.ttc fonts are not required anymore.
       Thanks to Jason Harrop.</description></item>
      <item><title>Apache FOP Renderers update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers update
        by
        JM
        :
        
        When a JPEG image is embedded, an optionally embedded color profile is filtered out
        as it's already embedded separately in the PDF file.
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
        :
        
        Added support for addressing all glyphs available in a Type 1 font, not just the ones
        in the font's primary encoding.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Added an event handling framework which allows to get better feedback from within FOP
        with the ability to customize problem management.
      </description></item>
    
    
      
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed a color selection problem which occurred after an image has been painted
        through the Graphics2DAdapter in PDF output.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 41306)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 41306)
        
        :
        
        Fixed page ordering problem with AWTRenderer.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 39980)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 39980)
        
        :
        
        Fixed image scaling for RTF output.
      </description></item>
      <item><title>Apache FOP API fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>API fix
        by
        JM
        :
        
        Fixed the -imagein command-line option.
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 43825)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 43825)
        
        :
        
        Added support for fo:leader for RTF output (no full support!). Fixes problems with empty leaders
        being used to force empty lines among other issues.
       Thanks to Maximilian Aster.</description></item>
      <item><title>Apache FOP Renderers add
          (bug 43824)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 43824)
        
        :
        
        Added support for page-number-citation for RTF output.
       Thanks to Maximilian Aster.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 43606)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 43606)
        
        :
        
        Fixed handling of proportional-column-width() and percentages for table column in RTF
        output.
       Thanks to Maximilian Aster.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 45295)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 45295)
        
        :
        
        Fixed NullPointerException when page-number-citations are used inside a marker.
      </description></item>
      <item><title>Apache FOP Images fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images fix
        by
        JM
        :
        
        Fixed two bugs concerning resolution handling with SVG images and their
        conversion to bitmaps for RTF output.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 44887)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 44887)
        
        :
        
        Fixed potential multi-threading problem concerning the use of DecimalFormat.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 44412)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 44412)
        
        :
        
        Regression bugfix: Multiple collapsible breaks don't cause empty pages anymore.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed resolution handling inside AWT preview dialog.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed positioning of absolutely positioned block-containers in multi-column documents.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed rendering of fixed block-containers in AFP output.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 44621)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 44621)
        
        :
        
        Various bugfixes for table layout.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed regression causing bad positioning of block-containers if used as descendant
        of a table-cell.
      </description></item>
      <item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
        :
        
        Fixed text extraction problem with ZapfDingbats and Symbol font in PDF output.
      </description></item>
      <item><title>Apache FOP Images fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images fix
        by
        JM
        :
        
        Fixed a performance problem concerning image serialization.
      </description></item>
      <item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
        :
        
        Fixed NullPointerException when loading a TrueType font using XML font metric files.
      </description></item>
    
    
      
      <item><title>Apache FOP Layout fix
          (bug 44412)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 44412)
        
        :
        
        Bugfix: The before border of a block is no longer swallowed if its first child issues
        a break-before.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 44412)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 44412)
        
        :
        
        Bugfix: When there was a forced break after a block with (conditional) borders the
        border-after wasn't painted.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Bugfix: a forced break inside a cell was ignored when occurring before the minimum height
        set on the enclosing row was set.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
        :
        
        Fixed exceptions when lists, tables or block-container are children of an inline-level
        FO.
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        VH
        :
        
        Added support for background on fo:table-column and fo:table-header/footer/body elements.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Fixed the rendering of the area of a table corresponding to border-separation, which must
        be filled with the background of the table, and not the rows.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Improved conformance: even if a table-cell spans several rows its background must
        correspond to the first row spanned.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Slight improvement for thin lines in Java2D/AWT output.
       Thanks to Gordon Cooke.</description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        VH
        :
        
        Added full support for keep-with-previous on fo:table-row and in fo:table-cell elements.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        MB
        :
        
        Turned on XInclude processing for the main source given on the command line.
      </description></item>
      <item><title>Apache FOP Fonts fix
          (bug 44451)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 44451)
        
        :
        
        Improved the font auto-detection so fonts accessed using the font-family name are
        selected with higher accuracy.
       Thanks to Justus Piater.</description></item>
      <item><title>Apache FOP API remove</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>API remove
        by
        JM
        :
        
        Removed deprecated methods in the "apps" package that were left-overs from the API
        discussions.
      </description></item>
      <item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
        :
        
        Added support for unusual font encodings (like for Symbol or Cyrillic fonts) of Type 1
        fonts in PDF and PostScript output.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 44321)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 44321)
        
        :
        
        Moved to the FO tree stage the check for break-before/after on table-row while spanning in
        progress.
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        VH
        :
        
        Added full support for breaks before and after table cells (that is, break-before/after set
        on the first/last child of a cell).
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        VH
        :
        
        Added full support for breaks inside the cells of a table.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 41631)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 41631)
        
        :
        
        Added correct percentage resolution for arguments to the proportional-column-width() function.
      </description></item>
      <item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
        :
        
        Bugfix for date formatting with negative time zones in the PDF's Info object.
        This affected PDF/A compliance.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added an option to disable the default sRGB profile in PDF output for those who
        don't care about color fidelity, but care about PDF file size.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 43705)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 43705)
        
        :
        
        Fixed a bug when the rgb-icc() function was used either before the fo:declarations,
        or in documents without a fo:declarations node. In such cases, the sRGB fallback
        is now used to avoid an ugly NullPointerException.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
        :
        
        Added very basic parsing for the xml:lang shorthand.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 44343)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 44343)
        
        :
        
        Fixed a bug when using relative font-size (smaller/larger) in combination
        with percentages.
      </description></item>
      <item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
        :
        
        Bugfix for handling of optional tables in subset TrueType fonts. This bug caused errors
        in various PDF viewers.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added support for the natural language indentifier ("Lang" in the document catalog)
        for PDF documents based on the language/country values on fo:page-sequence.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 44286)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 44286)
        
        :
        
        Fixed a memory-leak in XMLWhiteSpaceHandler.
       Thanks to Stefan Ziel.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 44289)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 44289)
        
        :
        
        Fixed the resolution of borders when header/footer is omitted at page breaks.
      </description></item>
      <item><title>Apache FOP Layout add
          (bug 43934)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        VH
          (fixes bug 43934)
        
        :
        
        Added support for conditional borders in tables, for both the separate and the collapsing
        border model.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 44160)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 44160)
        
        :
        
        Fixed a possible IndexOutOfBoundsException that could happen with certain constellations
        when footnotes are used.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
        :
        
        Compliance fix: for absolutely positioned block-containers, "top" wasn't
        interpreted correctly.
      </description></item>
      <item><title>Apache FOP Extensions add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Extensions add
        by
        JM
        :
        
        New extension attribute fox:transform on fo:block-container allows free-form transformation
        (rotation, scaling etc.) of absolute and fixed block-containers. Supported only
        for PDF, PS and Java2D-based renderers.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed logic error setting the transformation matrix for block-container viewports
        (applies to absolute and fixed block-containers only).
        Important: External renderer implementations need to adjust for the change and implement
        the new method concatenateTransformationMatrix(AffineTransform) if the renderer is
        derived from AbstractPathOrientedRenderer.
      </description></item>
      <item><title>Apache FOP Images fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images fix
        by
        JM
        :
        
        A new image loading framework has been introduced to fix various problems with external
        graphics and improve performance.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed generation of named destinations so it works when the PDF document is encrypted.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        PostScript output now generates the bounding box DSC comments for the whole document.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added support for PDF page labels.
      </description></item>
      <item><title>Apache FOP Renderers add
          (bug 44176)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 44176)
        
        :
        
        Added support for custom fonts in Java2DRenderer and derived renderers.
       Thanks to Patrick Jaromin.</description></item>
      <item><title>Apache FOP Extensions add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Extensions add
        by
        JM
        :
        
        Added new extension element: fox:external-document. It allows to add whole documents
        such as multi-page TIFF images to be inserted as peers to a page-sequence. Each image
        will make up an entire page. See the documentation for details.
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        JM
        :
        
        Added minimal support for the .minimum/.maximum components of block/inline-progression-dimension
        on fo:external-graphic and fo:instream-foreign-object.
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        JM
        :
        
        Added support for scale-down-to-fit and scale-up-to-fit (introduced in XSL 1.1).
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 43633)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 43633)
        
        :
        
        Bugfix: content of a row with zero height overriding the previous row
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 37993)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 37993)
        
        :
        
        Bugfix: allow multiple bookmarks to point at the same destination.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 43917)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 43917)
        
        :
        
        Bugfix for border-after painting and element list generation when a
        forced break is involved.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 40230)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 40230)
        
        :
        
        Bugfix: no empty page is generated anymore if there's no content
        after a break-after.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 43803)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 43803)
        
        :
        
        Restored proper handling of fo:table-cell having no children, which is allowed in relaxed
        validation mode.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
        :
        
        Memory Leak fixed in the Property Cache. Fixed by Jeremias Maerki. Reported and Tested By
        Chris Bowditch.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 43712)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 43712)
        
        :
        
        Bugfix in tables: wrong element generation by the merging algorithm when glues must be
        produced to cope with conditional spaces. The corresponding length was added twice: one in
        the glue itself and one in the following box.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix for URI resolution: Make StreamSources without system identifier work again.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 43910)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 43910)
        
        :
        
        Avoid a NullPointerException in AreaTreeHandler.endDocument().
       Thanks to David Delbecq.</description></item>
      <item><title>Apache FOP Layout fix
          (bug 43766)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 43766)
        
        :
        
        Bugfix: breaks generated by the merging algorithm for a table-row containing empty cells
        had always a penalty of 900.
      </description></item>
      <item><title>Apache FOP Layout add
          (bug 43605)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        JM
          (fixes bug 43605)
        
        :
        
        Added methods for fo:page-number-citation(-last) in FOEventHandler.
       Thanks to V. Schappert.</description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        VH
        :
        
        Step towards performance: the collapsing-border resolution algorithm no longer triggers the
        retrieving of the whole table, when possible.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        In case of missing cells the border-end of the table was applied to an inner cell, instead
        of the (empty) cell in the last column.
      </description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Fixed the resolution of borders with table-columns (border-before/after was wrongly applied
        to every cell of the column).
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 42768)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 42768)
        
        :
        
        Fixed the resolution of border-end on cells spanning several rows.
      </description></item>
      <item><title>Apache FOP Fonts fix
          (bug 43835)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 43835)
        
        :
        
        Bugfix: Use Font.getName() (logical font name) instead of Font.getFontName()
        (localized) when registering fonts from AWT.
       Thanks to David Churavy.</description></item>
      <item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
        :
        
        Made the way TrueType fonts are embedded in PDF compliant to the
        specification so viewers correctly identify subset fonts.
      </description></item>
      <item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
        :
        
        Fixed font-autodetection so fonts with uppercase extensions are
        detected, too.
      </description></item>
      <item><title>Apache FOP Fonts update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts update
        by
        JM
        :
        
        Improved font auto-detection and handling of AWT-supplied fonts in order
        to achieve better results when using multiple output formats. Whenever
        possible, the font names appearing in the operating system can also
        be used in XSL-FO.
      </description></item>
      <item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed regression: transparent-page-background was not recognized for PNG output.
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        VH
        :
        
        Added check for table-cells which span more rows than available in their parent element
        (table-header/footer/body).
      </description></item>
      <item><title>Apache FOP Layout add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        AD
        :
        
        Added support for fo:markers in fo:inline and fo:basic-link.
      </description></item>
      <item><title>Apache FOP Renderers update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers update
        by
        JM
        :
        
        PDF Transcoder (SVG) text painting has been completely rewritten.
        Except for some special cases (with filters for example), all text
        (including flow text) is now painted using PDF text operators.
      </description></item>
      <item><title>Apache FOP Layout add
          (bug 42748)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        AD
          (fixes bug 42748)
        
        :
        
        Added support for ids on empty fo:inlines.
      </description></item>
      <item><title>Apache FOP Fonts add
          (bug 42982)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        AC
          (fixes bug 42982)
        
        :
        
        Add Font support in jar files.
       Thanks to Max Berger.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 43042)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AC
          (fixes bug 43042)
        
        :
        
        Postscript extension cleanup.
       Thanks to Andrejus Chaliapinas.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 43587)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AC
          (fixes bug 43587)
        
        :
        
        Fix to avoid ClassCastException where multiple ps:ps-comments are declared within fo:declarations.
      </description></item>
      <item><title>Apache FOP Fonts fix
          (bug 43143)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        AC
          (fixes bug 43143)
        
        :
        
        Fix to avoid NullPointerException when parsing ExpertEncoded and ExpertSubsetEncoded Type 1 fonts.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 43439)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AC
          (fixes bug 43439)
        
        :
        
        Fixes missing TLE value attribute when using AreaTree input with the AFP renderer.
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added generic structures to the PDF library in order to support PDF
        file in fo:external-graphic later.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 43597)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
          (fixes bug 43597)
        
        :
        
        Added support for SVGZ.
       Thanks to Max Berger.</description></item>
      <item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
        :
        
        Bugfix for NPE with empty table-row (regression from 0.93).
      </description></item>
      <item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added a configuration setting to the PCL renderer to disable PJL commands.
      </description></item>
      <item><title>Apache FOP Renderers fix
          (bug 43464)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 43464)
        
        :
        
        Fix to avoid a ClassCastException in renderer configuration.
       Thanks to Bruno Feurer.</description></item>
      <item><title>Apache FOP Renderers fix
          (bug 43439)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 43439)
        
        :
        
        Fixed the restoration of the TLE values from the intermediate format
        for the AFP extension elements.
       Thanks to Adrian Cumiskey.</description></item>
      <item><title>Apache FOP Renderers add
          (bug 43041)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 43041)
        
        :
        
        Added a configuration setting for the renderer/device resolution to the AFP renderer.
       Thanks to Adrian Cumiskey.</description></item>
      <item><title>Apache FOP Layout update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout update
        by
        AD
        :
        
        Facilitate the implementation for font-selection-strategy:
        &#8226; Changed FontInfo.fontLookup to always return an array of FontTriplet.
        &#8226; Changed CommonFont.getFontState to return an array of FontTriplet.
        &#8226; Initial modifications to the related LMs: initialized with
            the font corresponding to the first of the triplets.
      </description></item>
      <item><title>Apache FOP Layout update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout update
        by
        AD
        :
        
        PropertyCache phase 2:
        &#8226; improvement of the PropertyCache itself should now guarantee acceptable
            performance of the static caches in multi-session environments, which is
            a possible problem with synchronizedMap.
        &#8226; changed CommonFont to use the cache:
            added CachedCommonFont to contain the properties that are always cacheable
            CommonFont itself is only cached if the remaining properties are absolutes.
        &#8226; changed CommonHyphenation, KeepProperty, ColorProperty and FontFamilyProperty to use the cache.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 42705)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 42705)
        
        :
        
        Fixed swallowing PCDATA in text-node children of
        retrieved markers.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 42703)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 42703)
        
        :
        
        Fixed erroneous white-space removal in retrieved markers.
      </description></item>
      <item><title>Apache FOP Layout fix
          (bug 43274)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 43274)
        
        :
        
        Fixed erroneous usage of inherited color-values in SVG.
       Thanks to ckohrn.at.tng.de.</description></item>
    
    
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        AFP Renderer: Bugfix for 1 bit images where the width is not a multiple of 8.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        MM
        :
        
        Support for keep-together.within-line="always".
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
        :
        
        Fixed incomplete support for Unicode Word Joiner characters (U+2060 and U+FEFF).
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
        :
        
        Add support for conditional spaces in table-cells.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 42785)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
          (fixes bug 42785)
        
        :
        
        Support alignment-adjust for images.
       Thanks to Max Berger.</description></item>
      <item><title>Apache FOP Code add
          (bug 41044)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
          (fixes bug 41044)
        
        :
        
        Partial application of the patch in Bugzilla 41044:
          * addition of a generic PropertyCache to be used by all Property
            types that can be safely canonicalized
          * modified EnumProperty, StringProperty, NumberProperty, EnumNumber
            and FixedLength to make use of the cache infrastructure
       Thanks to Richard Wheeldon.</description></item>
      <item><title>Apache FOP Code update
          (bug 41656)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        AD
          (fixes bug 41656)
        
        :
        
        Refactoring in the fo package:
        -&gt; removal of the childNodes instance member in fop.fo.FObj
        -&gt; addition of a firstChild instance member in fop.fo.FObj
        -&gt; addition of a siblings instance member in fop.fo.FONode
        -&gt; addition of a FONodeIterator interface in FONode + corresponding implementation in FObj
        -&gt; changed implementations of FObj.addChildNode(), .removeChild() and .getChildNodes()
      </description></item>
      <item><title>Apache FOP Code update
          (bug 42089)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        AD
          (fixes bug 42089)
        
        :
        
        Code cleanup and restructuring:
        Refactoring of PageSequenceLayoutManager and provide common FObj id property use
       Thanks to Adrian Cumiskey.</description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
        :
        
        Slight improvement of relative font-weight handling in the properties
        package.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        Updated PDF/A-1b support according to ISO-19005-1:2005/Cor.1:2007.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 41831)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
          (fixes bug 41831)
        
        :
        
        Add support for font auto-detection (easier font configuration).
       Thanks to Adrian Cumiskey.</description></item>
      <item><title>Apache FOP Code update
          (bug 42406)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
          (fixes bug 42406)
        
        :
        
        Use source resolution setting for bitmap images which don't provide their own
        resolution.
       Thanks to Hussein Shafie.</description></item>
      <item><title>Apache FOP Code fix
          (bug 42109)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 42109)
        
        :
        
        Fixed the rendering of zero-width spaces for certain fonts by not generating them into
        the area tree.
       Thanks to Paul Vinkenoog.</description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        LF
        :
        
        Fixed a problem with disappearing footnotes inside hyphenated inlines (and footnotes with hyphenated inline child).
      </description></item>
      <item><title>Apache FOP Code add
          (bug 42067)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
          (fixes bug 42067)
        
        :
        
        Add support for exact positioning of internal PDF links.
       Thanks to Paul Vinkenoog.</description></item>
      <item><title>Apache FOP Code fix
          (bug 41434)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 41434)
        
        :
        
        Fix PDF Genaration for non-ASCII compatible locales.
       Thanks to Martin Kögler.</description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
        :
        
        Fix several exceptions when break-before/after is set on the first/last row of a table.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
        :
        
        Fix extra page break when break-before is set on both a table and its first row.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
        :
        
        Make keep-with-next and keep-with-previous work on fo:table.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 36934)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH, JM
          (fixes bug 36934)
        
        :
        
        Add support for the collapsing-border model in tables.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JB
        :
        
        Add support for named destinations in PDF.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fixed a problem with keep-with-next on table-rows. Once a keep-with-next was set
        inside a table, the FO following the table would always be glued to the previous table.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fixed a problem with the auto-rotate-landscape setting in the PostScript renderer.
        It didn't generate the right setpagedevice command.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fixed an IllegalArgumentException for absolutely positioned block-containers with a
        border and no height/bpd set.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Add support for a two-pass production for PostScript output to minimize file size. This
        adds images only once and adds only the fonts that are really used.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 41652)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 41652)
        
        :
        
        If a line contained nothing but a linefeed, this didn't produce empty lines.
        Replaced the auxiliary zero-width box with a glue the width of a line,
        and shrinkable to zero-width.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 40120)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
          (fixes bug 40120)
        
        :
        
        Stricter FOP user configuration checking
       Thanks to Adrian Cumiskey.</description></item>
      <item><title>Apache FOP Code fix
          (bug 41572)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 41572)
        
        :
        
        Fix parsing 'url(...)' when the URL itself contains a bracketed part.
       Thanks to Erwin Tratar.</description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Support for GIF images in RTF output (RTF handler, only. Does not affect the RTF library.)
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fix for NPE with PNG images for RTF output.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
        :
        
        Fix for properly parsing font-family names containing spaces.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Support for soft masks (transparency) with ImageIO image adapter.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 41019)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        LF
          (fixes bug 41019)
        
        :
        
        Fix incorrect behaviour of the BreakingAlgorithm when some inline content is wider than
        the available ipd, causing a restart.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fix for PDF corruption when a TrueType font with spaces in its name is embedded and no
        XML font metrics file for that font is used.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 41426)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 41426)
        
        :
        
        Fix for ClassCastException when fo:wrapper was used as direct child of fo:flow.
        Note: "id" attributes are still not handled properly on fo:wrapper!
       Thanks to Adrian Cumiskey.</description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        MM
        :
        
        Added support for the soft hyphen (SHY) character.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        MM
        :
        
        Added support for line-height-shift-adjustment property.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        SP
        :
        
        Added support for the system property fop.home to
        cli.Main.getJARList().
      </description></item>
      <item><title>Apache FOP Code add
          (bug 40930)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
          (fixes bug 40930)
        
        :
        
        Added support for display-align for table-cell in RTF output.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        MM
        :
        
        Added support for UAX#14 type line breaking. Support does not extend across nested fo:inline elements.
      </description></item>
    
    
      
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        BD
        :
        
        Added support for the use of Open Type fonts
      </description></item>
      <item><title>Apache FOP Code update
          (bug 5535)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        BD
          (fixes bug 5535)
        
        :
        
        Enabled Copy/Paste from PDF content in Acrobat Reader for text using embedded TrueType fonts.
       Thanks to Adam Strzelecki, Victor Mote.</description></item>
      <item><title>Apache FOP Code update
          (bug 41044)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        SP
          (fixes bug 41044)
        
        :
        
        Commented out unused properties, in order to minimize memory usage.
       Thanks to Richard Wheeldon.</description></item>
      <item><title>Apache FOP Code update
          (bug 41009)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        SP
          (fixes bug 41009)
        
        :
        
        Removed unused attributes from TableCell.
       Thanks to Richard Wheeldon.</description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Added initial support for loading fonts without a pre-created XML font metric
        file.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 40729)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
          (fixes bug 40729)
        
        :
        
        Support for the rgb-icc() function and for a proprietary cmyk() function (for device CMYK
        colors only through the PDF renderer so far).
       Thanks to Peter Coppens.</description></item>
      <item><title>Apache FOP Code update
          (bug 40813)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
          (fixes bug 40813)
        
        :
        
        Minor fixes and improvements for the AWT Preview (keyboard shortcuts, scrolling, windows
        setup).
       Thanks to Richard Wheeldon.</description></item>
      <item><title>Apache FOP Code add
          (bug 40849)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
          (fixes bug 40849)
        
        :
        
        Added support for SVG in fo:instream-foreign objects for RTF output.
       Thanks to Dominic Brügger.</description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Fixed bug when the sum of column widths of a table is larger than the
        specified widths. The table width was not adjusted.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Nested tables with headers and footers were not handled correctly and could
        overlap with the region-after.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 40519)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
          (fixes bug 40519)
        
        :
        
        Added support for CCITT compression in the TIFFRenderer by switching to the ImageWriter
        abstraction from XML Graphics Commons.
       Thanks to Oliver Hernŕndez Valls.</description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Extension properties fox:orphan-content-limit and fox:widow-content-limit which
        help with list-block and table layout. See the documentation for details.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Configuration option in the Java2D-based renderers that allows to disable the default
        white background in order to produce bitmap output with transparency.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 39414)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 39414)
        
        :
        
        Split up FOText instances larger than 32K characters to avoid
        integer overflow during layout.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Corrected painting of shading patterns and position of links for SVG images
        inside FO documents.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        AD
        :
        
        Minor fix: correctly set negative values for ipd/bpd to zero.
      </description></item>
      <item><title>Apache FOP Code update
          (bug 35656)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        AD
          (fixes bug 35656)
        
        :
        
        Rework of default column-creation / column-width setting from
        cells in the first row.
      </description></item>
      <item><title>Apache FOP Code update
          (bug 40270)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        AD
          (fixes bug 40270)
        
        :
        
        Added relaxed validation for empty list-item-*, as suggested by Gary Reed.
       Thanks to Gary Reed.</description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        AD
        :
        
        Modified proportional-column-width() function to log an error if used
        with table-layout=auto
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
        :
        
        Deferred property resolution for markers until they are actually retrieved,
        which leads to percentages and relative font-sizes now getting the correct
        values. Also deferred white-space-handling for markers.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        Changed the way overflowing pages are handled. The overflow property on region-body
        is now used to define the behaviour.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fixed a memory-leak: The FO tree part of a page-sequence was not released when a
        page-sequence was finished.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Table headers and footers were swallowed when a table was nested in a list-block.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fixed a bug with indent handling when margins are used on a surrounding block and
        not start/end-indent.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 40106)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 40106)
        
        :
        
        Compatibility fix for GCJ (GNU Classpath): Using "UTF-16BE" instead of "UnicodeBigUnmarked"
        encoding.
       Thanks to Jeroen Meijer.</description></item>
      <item><title>Apache FOP Code fix
          (bug 40062)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 40062)
        
        :
        
        Fixed handling for CCITT Group 4 TIFF images with fill order 2.
       Thanks to Gilles Beaugeais.</description></item>
      <item><title>Apache FOP Code fix
          (bug 40048)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 40048)
        
        :
        
        Fixed setting of page margins in AWT Renderer like it was done in the print renderer.
       Thanks to Igor Istomin.</description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fixed two memory-leaks in image handling. The image cache is finally working
        properly.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 39608)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 39608)
        
        :
        
        Let numeric property values without a unit be treated as pixels like in HTML.
        This fixes certain NullPointerException when no units are specified.
        (Note: the use of pixels in XSL-FO is discouraged!)
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Potential multi-threading issue (ConcurrentModificationException)
        eliminated for ElementMapping classes.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        No more System.exit() and look &amp; feel setting calls inside the reusable
        parts of the AWT viewer.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Proper escaping of characters in list-items labels for RTF output.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
        :
        
        Bugfix: FOUserAgent specific configuration parameters specified in config file
        were not set when FOP was invoked from command line.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Added support for PDF/A-1b and PDF/X-3:2003. (Note: this may still be a bit
        incomplete. Feedback is welcome!)
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        The CIDSet object is now generated for CID fonts which are embedded in PDFs.
        (Required by PDF/A).
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        The Java2DRenderer (and therefore the print and bitmap renderers) is now
        offering the same quality as the PDF and PS renderers. Note: There can still
        be little differences between PDF and Print/PNG/TIFF because the latter uses
        a different font metrics source.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 39712)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 39712)
        
        :
        
        Bugfix: components of the border-separation property weren't set when
        in shorthand-mode, leading to a NPE being thrown.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Table headers were omitted when a table is a child of a block-container.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Bookmarks in PDF will be generated even if some bookmarks cannot be
        resolved.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 39560)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 39560)
        
        :
        
        Bugfix: the interaction between the table FOs and properties package in
        determining initial values for column-number should be a one-time process,
        not repeated when the table is in a marker that is retrieved.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: All fonts names were converted unnecessarily to lower case in RTF output.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: The combination of hyphenation and kerning resulted in slightly ragged
        right ends for right-aligned and justified text.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: NullPointerException in AreaAdditionUtil in a table-cell spanning
        multiple pages and with a marker.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 39533)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 39533)
        
        :
        
        Bugfix: NullPointerException in RTF output when a table does not contain
        table-columns.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 39607)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 39607)
        
        :
        
        Bugfix: NullPointerException in RTF library when there are no borders on
        the parent table.
       Thanks to Julien Aymé.</description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
       Automatic support for all fonts available to the Java2D subsystem for all
       Java2D-descendant renderers (TIFF, PNG, print, AWT).
     </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Improved baseline detection in TTFReader for TrueType fonts.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 39443)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 39443)
        
        :
        
        Bugfix: tables nested in inline elements caused a NullPointerException.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        The default sRGB color profile provided by the Java class library is no longer
        embedded if it is encountered. This should reduce the PDF size considerably.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 39443)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 39443)
        
        :
        
        Bugfix: Sections with span="all" lead to overlapping text if spanning multiple pages.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
        :
        
        Bugfix: Percentages in vertical-align property values were not correctly handled.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 38243)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 38243)
        
        :
        
        Bugfix: Gaps in table-columns cause a NullPointerException.
       Thanks to Gerhard Oettl.</description></item>
      <item><title>Apache FOP Code update
          (bug 38946)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
          (fixes bug 38946)
        
        :
        
        Changed the internal representation of colors to use Java's own color infrastructure
        instead of FOP's home-grown classes.
       Thanks to Max Berger.</description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
        :
        
        Bugfix: TABs were not correctly replaced by spaces in some circumstances.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        Content in block-containers makes better use of shrink to fit content vertically
        into the available area. This can be used indirectly to justify content vertically
        in a block-container.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: basic-links with internal destinations in documents with multiple
        page-sequences sometimes pointed at the wrong page.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Fixed ClassCastException when retrieve-marker is used as a direct child
        if static-content in which case leading and trailing white space is not properly
        removed.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 39285)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 39285)
        
        :
        
        Bugfix: Fixed OutOfMemoryException with long data URLs (RFC 2397).
      </description></item>
      <item><title>Apache FOP Code add
          (bug 39118)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
          (fixes bug 39118)
        
        :
        
        Initial support for page-number-citation-last (XSL 1.1). Works without problems
        only for page-sequence so far.
       Thanks to Pierre-Henri Kraus.</description></item>
    
    
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: The generation of the PDF "d" (setdash) command was assuming that
        only integer values can be used but that isn't the case. Dash patterns
        PDFGraphics2D would be wrong in the process.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Fixed a division by zero problem in TTFReader and improved the detection
        of the capHeight and xHeight font metric values for TrueType fonts.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Allow URLs in basic-link's external-destination to be wrapped in "url()".
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
        :
        
        Bugfix: Corrected enumerated property value for white-space property
        from "no-wrap" to "nowrap".
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 38457)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
          (fixes bug 38457)
        
        :
        
        Bugfix: Added support for white-space-treatment="preserve" in particular to
        support the white-space="pre" short hand property.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Corrected expectation and behaviour for the text-indent property to only apply
        to the first line area generated by a block.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix for invalid handling of ICC color profiles in JPEG images and for
        dealing with CMYK JPEG images with the Adobe APPE marker.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Initial support for page-position="last" added.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Reenabled loading of user-supplied hyphenation patterns that was available in
        FOP 0.20.5. (See "hyphenation-base" option in the user configuration)
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Certain filter combinations in PDF could lead to invalid PDFs.
        DecodeParams were not properly handled.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: CCITT Group 4 encoded TIFF images with multiple strips are now properly
        embedded in PDF files.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Added support for fixed-width spaces.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Added support for kerning.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Fixed a copy/paste error in the table layout code that caused wrong page
        break decisions when table-headers and/or table-footers are used.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Fixed an NPE that was thrown when a table was used inside a footnote-body.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Fixed a problem with certain TrueType fonts which are missing the "PCLT"
        table, where a baseline-shift="sub" had no effect due to a missing x-height value.
        (Note: This only affects TTFReader, so the font metric file has to be regenerated.)
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: When the base URL was specified as a file system path, the constructed
        URL was wrong.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Support for "userconfig" attribute in FOP Ant Task.
       Thanks to Jirí Mare&#353;.</description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Initial support for XMP metadata (PDF 1.4) under fo:declarations.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
        :
        
        Added support for the background-position shorthand property.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
        :
        
        Added support for the font shorthand property.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 38618)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
          (fixes bug 38618)
        
        :
        
        Added support for system-color() function.
       Thanks to Max Berger.</description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Fixed two causes for ClassCastExceptions in BlockContainerLayoutManager.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: padding-top and padding-bottom on list-items could lead to wrong page
        break decisions and thus to overlapping text.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: break-before and break-after were ignored on list-items.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 38507)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        LF
          (fixes bug 38507)
        
        :
        
        Bugfix: The elements representing a non-breaking space weren't always correct.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 38453)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 38453)
        
        :
        
        Bugfix: Text-decoration was not promoted if no text-decoration attribute was
        specified on a nested element.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 38282)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
          (fixes bug 38282)
        
        :
        
        Added support for the from-table-column() function.
       Thanks to Gerhard Oettl (gerhard.oettl.at.oesoft.at).</description></item>
      <item><title>Apache FOP Code fix
          (bug 38397)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 38397)
        
        :
        
        Bugfix: Spanned cells could lead to an false error message about overlapping
        cells and ultimately a NullPointerException.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Regions with non-standard names got ignored in RTF output leading to
        missing headers and footers.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        The RTF output now properly generates the "\landscape" flag for documents in
        landscape orientation.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Following a clarification by the XSL FO SG, space traits are only set on the
        first and last area generated by an FO, and not on every area anymore.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        New feature: "Intermediate format" (IF). The IF is basically the XML dialect
        written by the area tree renderer (XMLRenderer). A new parser for this format
        allows reparsing a serialized and possibly modified area tree and rendering it
        to the final target format.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Floating point numbers were not properly formatted in the PDF renderer
        which could lead to error messages while opening a PDF in Acrobat Reader.
      </description></item>
      <item><title>Apache FOP Code update
          (bug 38098)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        SP
          (fixes bug 38098)
        
        :
        
        Implement property name as default argument on some xsl-function calls.
       Thanks to Gerhard Oettl.</description></item>
      <item><title>Apache FOP Code update
          (bug 38087)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        SP
          (fixes bug 38087)
        
        :
        
        Implement force-page-count property of page-sequence.
       Thanks to Gerhard Oettl.</description></item>
      <item><title>Apache FOP Code fix
          (bug 38054)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 38054)
        
        :
        
        Bugfix: Spans that end up with a negative height don't get swallowed anymore.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 36729)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        MM
          (fixes bug 36729)
        
        :
        
        Relative URLs for the font configuration attributes metrics-url and embed-url
        are now supported. A new configuration property font-base has been added. It
        sets the base URL against which relative font URLs are resolved. If font-base is
        not set base is used.
      </description></item>
      <item><title>Apache FOP Code add
          (bug 38132)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
          (fixes bug 38132)
        
        :
        
        Added support for RFC2397 "data" URLs.
       Thanks to Richard Wheeldon.</description></item>
      <item><title>Apache FOP Code fix
          (bug 38132)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 38132)
        
        :
        
        Bugfix: Certain border styles could lead to a NullPointerException.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 38102)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 38102)
        
        :
        
        Bugfix: Space was not adjusted if the space was on a nested block. This could
        lead to content overflowing the bottom of a page.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: TableCell did not properly report that it generates reference-areas
        which could lead to wrong inherited values for start-indent and end-indent.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        The font loading code now reads the encoding value from the XML font metrics file
        so that fonts like Symbol and ZapfDingbats can be embedded explicitely (Required by PDF/A).
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        SP
        :
        
        Improvements to the code for inline block content.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 38089)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
          (fixes bug 38089)
        
        :
        
        Bugfix: Image height for BMP images was incorrectly calculated
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        AD
        :
        
        Revision of refinement white-space handling.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
        :
        
        Added feature: support for white-space shorthand
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
        :
        
        Added feature: support for page-break-* shorthands
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 38053)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
          (fixes bug 38053)
        
        :
        
        Bugfix: NullPointerException on certain fo:inline within lists.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 37743)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
          (fixes bug 37743)
        
        :
        
        Bugfix: ClassCastException on certain fo:inline with border combinations.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
        :
        
        Changed a method name in LineArea from finalize to finalise because it was
        never intended for the method to be an override of the Java Object finalize
        method. If invoked by the Java garbage collector it may cause a NPE.
      </description></item>
    
    
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        Deprecated Fop constructors that use integer constants to select the
        output format have been removed in favor or the constructors that use
        MIME types.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
        :
        
        Fixed a bug where the linefeed-treatment property value "preserve" was not
        honoured when used in conjunction with text-align="center".
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 37964)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 37964)
        
        :
        
        Bugfix: hard breaks with even-page or odd-page were not handled correctly
        when spaces were surrounding the break.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        Changed the XMLHandler interface so it doesn't report the MIME type it
        supports but instead can report whether it supports a particular Renderer
        implementation. XMLHandlers are now configurable.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fixed a bug where SVG content could be clipped when rendered to PostScript.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Changed the way resolutions are handled. The single resolution in the user
        agent got split up into source and target resolutions. For more info, see
        the updated documentation. Note: backwards-incompatible change!
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 37875)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 37875)
        
        :
        
        Bugfix: Some content inside a table-header may not have been renderered on
        pages n &gt; 1 in certain conditions.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MM
        :
        
        Fixed a bug where an empty line, i.e. a block containing only a &amp;nbsp;,
        was not rendered at all.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fixed a bug where the area for a finished cell that is broken over pages was
        created once for each row it was spanned over instead of only once.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Added checks that warn about tables and block-containers that are wider than
        the available content area.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 37880)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 37880)
        
        :
        
        Bugfix: Footnotes were lost if the footnote appeared in centered text.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        Improved log and error messages in a number of places by adding additional
        context information that should make it easier to find the location in the
        source files.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Fix to correct image sizes in RTF output.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        First attempt at SVG support in RTF output. SVG images are converted to 300dpi JPEG
        images internally.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        Additional checks to detect text overflows. The overflow property is now properly
        handled where applicable.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        Source location information improved. If location information is not available,
        the context information is provided based on text content.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        The command-line now automatically sets two parameters for any XSLT transformation:
        "fop-output-format" contains the MIME type of the currently selected output format,
        "fop-version" contains FOP's version number.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        The output file is now deleted when an exception occurs when calling FOP from
        the command-line.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Areas for table-cells that are broken over more than one page are now
        generated even if all its content is already painted on a previous page. This
        fixes strange effects like a table grid that is not completely painted.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 37828)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 37828)
        
        :
        
        Bugfix: Column balancing produced strange break decisions in certain multi-column
        documents with large amounts of text.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Added an alternative set of rules for calculating text indents which tries to mimic
        the behaviour of many commercial FO implementations that chose to break the rules
        in the FO specification in order to better meet the natural expectations of
        inexperienced FO users.
      </description></item>
      <item><title>Apache FOP Code fix
          (bug 37815)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 37815)
        
        :
        
        Bugfix: The combination of content-width="scale-to-fit" and content-height="100%"
        did not work as expected due to a datatype conversion bug.
       Thanks to Tom Craddock.</description></item>
      <item><title>Apache FOP Code fix
          (bug 37813)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
          (fixes bug 37813)
        
        :
        
        Bugfix: A span="all" on the first block cause a subsequent page break and the first block
        didn't span all columns.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Self-created OutputStreams in PNG Renderer were not properly closed.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        The border-collapse property on fo:table is now forced to the value "separate" until the collapsing
        border has been implemented.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        font-family list still not fully supported but a comma-separated list is now properly tokenized.
        FOP will now go through all fonts in the list to find one that is available, but it doesn't
        do so per character, yet.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Implemented "Overconstrained Geometry" rules (5.3.4, XSL 1.0) for the most important cases.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Relatively positioned BlockViewports (from block-containers) caused the paint
        cursor not be be properly advanced when space-before or space-after were present.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix: Space resolution was incomplete for content in table-cells. Conditional elements
        didn't get removed.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        The validation check for non-zero borders and padding on a region-* and for empty static-content
        elements is now turned off when relaxed validation is active to improve compatibility with
        FO documents written for other FO implementations.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix for "/ by zero" ArithmeticExceptions when an URL to a non-existing image is used
        and content-width and/or content-height is used.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix for a multi-threading problem:
        propertyListTable initialization moved from the constructor to a static block in FONode.
        This fixes NullPointerExceptions in PropertyList.
      </description></item>
      <item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        JM
        :
        
        Bugfix for placement of text inside a text area when borders are present in PostScript output.
      </description></item>
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        JM
        :
        
        Improvements on leader painting in PDF output.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        JM
        :
        
        Support for leader painting in PostScript output.
      </description></item>
      <item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        LF, MM
        :
        
        Support for hyphenation-ladder-count.
      </description></item>
    
    
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        all
        :
        
        Complete redesign of the FOP codebase in the period between Dec 2001 and Nov 2005.
        There are just too many changes to list here. If you like to know details, run
        "svn log --verbose http://svn.apache.org/repos/asf/xmlgraphics/fop/trunk/".
      </description></item>
    
    
      <item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        all
        :
        
        For the change log for the maintenance branch
        (where FOP 0.20.5 came from), please see the "CHANGES" file in the distribution, or
        the CHANGES file in the SVN repository.
      </description></item>
    
  

  

<item><title>Apache FOP Test fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Test fix
        by
        GA
        :
        
        Fix errors and warnings in example files. Add build.xml for documentation examples.
      </description></item><item><title>Apache FOP Code fix
          (bug 53458)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53458)
        
        :
        
        Fix incorrect language and country code key generation in hyphenation tree cache.
       Thanks to Dieter von Holten.</description></item><item><title>Apache FOP Images fix
          (bug 53431)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images fix
        by
        GA
          (fixes bug 53431)
        
        :
        
        Fix incorrect SVG line dash pattern with PDF output format.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Images update
          (bug 40676)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images update
        by
        GA
          (fixes bug 40676)
        
        :
        
        Fix interoperability issue with Adobe reader regarding use of multiple filters.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
        :
        
        Eliminate javadocs warnings.
      </description></item><item><title>Apache FOP Renderers add
          (bug 52338)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        VH
          (fixes bug 52338)
        
        :
        
        Added possibility to embed TrueType fonts in PostScript.
      </description></item><item><title>Apache FOP Images update
          (bug 40676)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images update
        by
        GA
          (fixes bug 40676)
        
        :
        
        Update site documentation about PNG image loading configuration and support.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Images update
          (bug 40676)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images update
        by
        GA
          (fixes bug 40676)
        
        :
        
        Fix newly introduced findbugs warnings.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Images fix
          (bug 40676)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Images fix
        by
        GA
          (fixes bug 40676)
        
        :
        
        Support use of ImageLoaderRawPNG decoder in order to prevent re-encoding of PNG images (and unnecssary output file bloat).
       Thanks to Luis Bernardo, Matthias Reischenbacher.</description></item><item><title>Apache FOP Code fix
          (bug 53412)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53412)
        
        :
        
        Eliminate incorrect use of object identity which produces excessive property cache collisions.
       Thanks to Alexios Giotis.</description></item><item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
        :
        
        Eliminate javadocs warnings.
      </description></item><item><title>Apache FOP Code update
          (bug 53055)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        GA
          (fixes bug 53055)
        
        :
        
        Update xmlgraphics common jar to reflect recent fixes in XGC.
      </description></item><item><title>Apache FOP Code update
          (bug 43940)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        GA
          (fixes bug 43940)
        
        :
        
        Fix handling of NaN, {+,-}Infinity, and other edge cases. Submitted by Julien Aymé.
       Thanks to Julien Aymé.</description></item><item><title>Apache FOP Renderers fix
          (bug 53304,53306)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 53304,53306)
        
        :
        
        Add version attribute to AT and IF intermediate formats. Also eliminate redundant use of reversed attribute in AT format.
      </description></item><item><title>Apache FOP Renderers fix
          (bug 53295)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 53295)
        
        :
        
        Add extension to place code just before PostScript %PageTrailer.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Renderers fix
          (bug 53294)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 53294)
        
        :
        
        Fix invalid PostScript file being created when font-size is 0.
       Thanks to Robert Meyer.</description></item><item><title>Apache FOP Docs update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Docs update
        by
        GA
        :
        
        Update FAQ and New Bug documentation.
      </description></item><item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
        :
        
        Added support for the role property on fo:page-sequence, fo:flow and fo:static-content. This 
        allows to change the mapping of those FOs to PDF structure types when enabling 
        accessibility.
      </description></item><item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        VH
        :
        
        Stop outputting the Type entry for structure elements in order to create a smaller PDF 
        ouptut when accessibility is enabled.
       Thanks to Martin Koegler.</description></item><item><title>Apache FOP Config fix
          (bug 52144)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Config fix
        by
        GA
          (fixes bug 52144)
        
        :
        
        Fix crash on use of version switch (-v).
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Renderers fix
          (bug 53242)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 53242)
        
        :
        
        Support fractional line widths in AFP renderer, fixing problem with SVG line drawing.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Config fix
          (bug 53248)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Config fix
        by
        GA
          (fixes bug 53248)
        
        :
        
        Fix exception thrown from use of -print option in CLI.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Docs fix
          (bug 53247)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Docs fix
        by
        GA
          (fixes bug 53247)
        
        :
        
        Fix renderer mime type for PCL output; should be application/x-pcl.
      </description></item><item><title>Apache FOP Renderers fix
          (bug 40699)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 40699)
        
        :
        
        Fix for invalid PDF for certain numerical values in SVG lineargradient.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Layout fix
          (bug 53185)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 53185)
        
        :
        
        Unify date formatting between FOP and XGC as well as tidying the date format code.
       Thanks to Robert Meyer.</description></item><item><title>Apache FOP Layout fix
          (bug 45715)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 45715)
        
        :
        
        Fix for break before (break-before) not respected on blocks nested in inlines.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Renderers fix
          (bug 48723)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 48723)
        
        :
        
        Fix for XGC when rendering PostScript using SVG being drawn upside down when using a custom affine transform.
       Thanks to Robert Meyer.</description></item><item><title>Apache FOP Code fix
          (bug 43940)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 43940)
        
        :
        
        Use new double format utility to improve thread safety and performance.
       Thanks to Ognjen Blagojevic.</description></item><item><title>Apache FOP Fonts fix
          (bug 53148)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        GA
          (fixes bug 53148)
        
        :
        
        Fix performance regression in JDK 1.6 Update 19 due to use of Java Beans API. Fix checkstyle errors.
       Thanks to Tassos Charoulis.</description></item><item><title>Apache FOP Renderers fix
          (bug 51484)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 51484)
        
        :
        
        Don't write final /sect suffix in RTF if section is last section.
       Thanks to Benjamin Riefenstahl.</description></item><item><title>Apache FOP Fonts fix
          (bug 53143)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        GA
          (fixes bug 53143)
        
        :
        
        Ensure fonts are not loaded twice (redundantly).
      </description></item><item><title>Apache FOP Test update
          (bug 50196)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Test update
        by
        GA
          (fixes bug 50196)
        
        :
        
        Add test for basic-link with padding.
       Thanks to Matthias Reischenbacher.</description></item><item><title>Apache FOP Code update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        GA
        :
        
        Improve property function argument parsing, specifically, better separate required, optional, and variable arguments and the handling of optional argument defaults.
        Regularize property function class names.
      </description></item><item><title>Apache FOP Layout fix
          (bug 51043)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 51043)
        
        :
        
        Don't restart layout unless abs(ipd difference) &gt; 1 in order to prevent rounding issues from triggering false restart.
       Thanks to Pascal Sancho.</description></item><item><title>Apache FOP Fonts update</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts update
        by
        GA
        :
        
        Removing experimental feature that violates XSL-FO and Unicode semantics by misinterpreting Basic Latin code points. Users must use private use codepoints to access font specific
        character mappings that have no assigned Unicode code point. See bug 50492.
      </description></item><item><title>Apache FOP Layout fix
          (bug 53103)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 53103)
        
        :
        
        Ensure that table cell spanning works in right-to-left writing mode.
       Thanks to Matthias Reischenbacher.</description></item><item><title>Apache FOP Layout fix
          (bug 53086)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 53086)
        
        :
        
        Ensure that table footer and header are included in bididirectional resolution.
      </description></item><item><title>Apache FOP Layout fix
          (bug 53097)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 53097)
        
        :
        
        Ensure writing-mode specified on fo:table is used to determine writing mode of table and its descendants.
      </description></item><item><title>Apache FOP Code fix
          (bug 53094)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53094)
        
        :
        
        Convert block container overflow exception to event model, improving overflow property behavior.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Code update
          (bug 51617)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code update
        by
        GA
          (fixes bug 51617)
        
        :
        
        Add run target for embedded examples. Add increased JVM memory heap flag for example8 in case font cache is rebuilt.
      </description></item><item><title>Apache FOP Code fix
          (bug 53083)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53083)
        
        :
        
        Update to use of checkstyle-5.5 as default configuration. Remove checkstyle-4.0 configuration. Also, import environment build properties before local properties, so that latter can refer to former.
      </description></item><item><title>Apache FOP Code fix
          (bug 52572)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 52572)
        
        :
        
        Prevent NPE on use of unsupported collapse-with-precedence; fall back to collapse. Fix checkstyle errors from prior commit.
       Thanks to Pascal Sancho.</description></item><item><title>Apache FOP Layout fix
          (bug 52514)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        GA
          (fixes bug 52514)
        
        :
        
        Ensure square image is appropriately scaled.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Code fix
          (bug 50062)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 50062)
        
        :
        
        Invoke JVM in headless mode from FOP command scripts and JS shell to prevent stealing focus from GUI applications.
      </description></item><item><title>Apache FOP Renderers fix
          (bug 52114)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        GA
          (fixes bug 52114)
        
        :
        
        Take leading derived space before/after into account when computing rows for TXT renderer.
      </description></item><item><title>Apache FOP Code add
          (bug 49893)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
          (fixes bug 49893)
        
        :
        
        A global setting to wrap F11 images in page segments.
      </description></item><item><title>Apache FOP Code fix
          (bug 52763)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 52763)
        
        :
        
        Support list-block in marker, thus preventing NPE.
      </description></item><item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
        :
        
        Must use unqualified (local name) when reporting invalid child error.
      </description></item><item><title>Apache FOP Code fix
          (bug 53065)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53065)
        
        :
        
        Restore lookup on Event message lookup field part. Add locale field to Event to
        enable locale dependent deferred bundle load during lookup field part substitution.
      </description></item><item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MH
        :
        
        Bug in AFP font metrics that performed integer arithmetic when it should have been
	double arithemetic.
      </description></item><item><title>Apache FOP Code fix
          (bug 49754)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 49754)
        
        :
        
        Bring clone() in line with the recommendations in Object.clone().
       Thanks to Simon Pepping.</description></item><item><title>Apache FOP Code fix
          (bug 52966)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 52966)
        
        :
        
        How to use native text with EPSDocumentGraphics2D.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Code fix
          (bug 51599)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51599)
        
        :
        
        Allow https scheme URI for PDF external action target.
       Thanks to Paul Huemer.</description></item><item><title>Apache FOP Code fix
          (bug 50901)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 50901)
        
        :
        
        RTF percentage table column width not calculated from table.
       Thanks to Carsten Pfeiffer.</description></item><item><title>Apache FOP Code fix
          (bug 51009)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51009)
        
        :
        
        RTF generates unexpected lines for blocks in tables. Also fix three findbugs issues.
       Thanks to Max Aster.</description></item><item><title>Apache FOP Code fix
          (bug 51007)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51007)
        
        :
        
        RTF tables do not support percent column-widths.
       Thanks to Max Aster.</description></item><item><title>Apache FOP Code fix
          (bug 50435)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 50435)
        
        :
        
        Access denied (java.util.PropertyPermission org.apache.fop.fo.properties.use-cache read).
       Thanks to Armin Haaf.</description></item><item><title>Apache FOP Code fix
          (bug 49763)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 49763)
        
        :
        
        Incorrect message when encountering a block in an inline in a footnote.
       Thanks to Adrian Buza.</description></item><item><title>Apache FOP Code fix
          (bug 47380)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 47380)
        
        :
        
        Specified rule-thickness applies only when leader-pattern is rule, otherwise should use default thickness.
       Thanks to Georg Datterl.</description></item><item><title>Apache FOP Code fix
          (bug 49302)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 49302)
        
        :
        
        Eliminate duplicate code.
       Thanks to Julien Aymé.</description></item><item><title>Apache FOP Code fix
          (bug 49350)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 49350)
        
        :
        
        Correct coding error in AFPResourceLevel#equals.
       Thanks to Julien Aymé.</description></item><item><title>Apache FOP Code fix
          (bug 51836)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51836)
        
        :
        
        Throw IFException instead of NPE if navigation target (page reference) doesn't exist.
       Thanks to Melanie Drake.</description></item><item><title>Apache FOP Code fix
          (bug 51808)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51808)
        
        :
        
        Fixed memory waste in traits map.
       Thanks to Sergey Vladimirov.</description></item><item><title>Apache FOP Code fix
          (bug 51807)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 51807)
        
        :
        
        Fixed small memory waste in rowCells array construction.
       Thanks to Sergey Vladimirov.</description></item><item><title>Apache FOP Code fix
          (bug 53005)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        GA
          (fixes bug 53005)
        
        :
        
        Fixed incorrect rejection of fo:wrapper inside fo:inline inside fo:footnote-body.
       Thanks to Alberto Simőes.</description></item><item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
        :
        
        Added support for PDF Object Streams. When accessibility is enabled and PDF version 1.5 
        selected, the structure tree will be stored in object streams in order to reduce the size of 
        the final PDF.
       Thanks to Peter Hancock.</description></item><item><title>Apache FOP Code fix
          (bug 46962)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
          (fixes bug 46962)
        
        :
        
        Fixed deadlock in PropertyCache.
       Thanks to Alexios Giotis.</description></item><item><title>Apache FOP Config add
          (bug 51385)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Config add
        by
        VH
          (fixes bug 51385)
        
        :
        
        Added configuration option to set the version of the output PDF document.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Code fix
          (bug 52849)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        MH
          (fixes bug 52849)
        
        :
        
        Fixed bug that caused a configured and installed SVG font to be stroked,
        also added an event indicating when fonts are stroked.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Code fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        PH
        :
        
        Fix of a bug introduced when merging ImproveAccessibility.
      </description></item><item><title>Apache FOP Code add
          (bug 50391)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
          (fixes bug 50391)
        
        :
        
          Improved support for empty flow-name mapping.
      </description></item><item><title>Apache FOP Layout add
          (bug 32789, 49008, 49687)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout add
        by
        GA
          (fixes bug 32789, 49008, 49687)
        
        :
        
        Add support for complex scripts, including: full bidi support, support for advanced
        typographic tables, advanced support for number conversion.
      </description></item><item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        GA
        :
        
        Add support for OpenType advanced typographic tables (GDEF, GSUB, GPOS).
      </description></item><item><title>Apache FOP Code fix
          (bug 52655)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
          (fixes bug 52655)
        
        :
        
        Fixed rendering of special glyphs when using single-byte encoding mode.
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Code add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
        :
        
        Improvements of the Accessibility features.
       Thanks to Vincent Hennebert.</description></item><item><title>Apache FOP Code add
          (bug 52416)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        CB
          (fixes bug 52416)
        
        :
        
        Suppress unnecessary "font not found warnings" when generating AFP with raster fonts 
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Code add
          (bug 51209)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        CB
          (fixes bug 51209)
        
        :
        
        SVG text in AFP creates miscoded GOCA text
       Thanks to Luis Bernardo.</description></item><item><title>Apache FOP Code add
          (bug 50391)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        CB
          (fixes bug 50391)
        
        :
        
        Add support for different flow-name of fo:region-body in FOP
       Thanks to Peter Hancock.</description></item><item><title>Apache FOP Code add
          (bug 51664)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        CB
          (fixes bug 51664)
        
        :
        
        Tagged PDF performance improvement plus tests
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Code add
          (bug 52197)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        MH
          (fixes bug 52197)
        
        :
        
        Improved AdobeStandardEncoding support in AFM files for type1 fonts
      </description></item><item><title>Apache FOP Code add
          (bug 52151)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
          (fixes bug 52151)
        
        :
        
        Added ant script to get JaCoCo code coverage.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Code add
          (bug 52136)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
          (fixes bug 52136)
        
        :
        
        Added to build file JUnit target that uses a regex to run all of the test cases. This 
        reduces the risk that some of them are omitted when building FOP.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Code add
          (bug 52089)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
          (fixes bug 52089)
        
        :
        
        Allow JPEG images to be embedded in an AFP document as is, without being decoded and 
        encoded.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Code add
          (bug 52010)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
          (fixes bug 52010)
        
        :
        
        Simplification of the build: Reduced code duplication and layout engine tests.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Various bugfixes to make PDFDocumentGraphics2D operational again.
      </description></item><item><title>Apache FOP Code add
          (bug 51962)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        PH
          (fixes bug 51962)
        
        :
        
        Fix for when the last simple-page-master referenced in a page-sequence-master is not
        chosen when force-page-count=odd.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Code add
          (bug 51928)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        VH
          (fixes bug 51928)
        
        :
        
        Upgraded all tests to JUnit 4.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Fonts fix
          (bug 48696)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        PH
          (fixes bug 48696)
        
        :
        
        Bugfix for color model in IOCA IDE structure parameter for 4- and 8-bit grayscale images.
        Revision 4.
      </description></item><item><title>Apache FOP Fonts fix
          (bug 51760)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        PH
          (fixes bug 51760)
        
        :
        
        Changes the way PostScript handles Graphics2D images such that if the language is set to
        level 3, the image is stored as an embedded file which has no length limit.  Previously it
        was stored as an array which has a implementation limit of 65535 elements.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Fonts fix
          (bug 51759)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        PH
          (fixes bug 51759)
        
        :
        
        PDFFactory responsible for asdigning name to a subset font.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Fonts fix
          (bug 51530)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        PH
          (fixes bug 51530)
        
        :
        
        Improved support for EBCDIC encoded double byte fonts fo AFP.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Fonts fix
          (bug 51205)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        PH
          (fixes bug 51205)
        
        :
        
        Corrected typographical errors in AFPBase12FontCollection.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Renderers fix
          (bug 48062)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        PH
          (fixes bug 48062)
        
        :
        
        Improved fix of a bug relating to PCL painter thread safetly.  Previous fix in rev 895012
        worked by synchronizing methods of a static instance of Java2DFontMetrics.  This fix uses a
        unique instance for per thread.
      </description></item><item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        PH
        :
        
        Fixed a bug in AFP where an ArrayOutofBoundsException is throwqn when embedding a Page 
        Segment.
      </description></item><item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        VH
        :
        
        Added support for 128bit encryption in PDF output.
       Thanks to Michael Rubin.</description></item><item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        PH
        :
        
        Fixed a bug in AFP where the object area axes of an Include Object was incorrectly set when 
        rotated by 180. </description></item><item><title>Apache FOP Fonts fix
          (bug 51596)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 51596)
        
        :
        
        Fixed a bug in TTF subsetting where a composite glyph could get
        remapped more than once resulting in garbled character.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Fonts fix
          (bug 50605)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 50605)
        
        :
        
        Fixed a number of bugs concerning Type 1 and other single-byte fonts
        (glyph width mismatches and overlapping characters).
      </description></item><item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Fixed a multi-threading bug for SVG images included through svg:image inside SVG documents.
      </description></item><item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        PH
        :
        
        Added an IFDocumentHandler filter for triggering rendering events.  Created an Event that
        captures an end page event with the page number.
      </description></item><item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        VH
        :
        
        Fix for alternative text not working in tagged PDF for TIFF images.
      </description></item><item><title>Apache FOP Renderers fix
          (bug 50909)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        PH
          (fixes bug 50909)
        
        :
        
        Fixed io exception in MODCAParser caused by the improper use of mark() and reset() on the
        MODCA data input stream.  Added unit test. </description></item><item><title>Apache FOP Fonts fix
          (bug 51144)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        JM
          (fixes bug 51144)
        
        :
        
        Removed invalid entries in ToUnicode table of CID subset fonts. 
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Renderers fix
          (bug 50899)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 50899)
        
        :
        
        Fixed mapping of font weights between CSS values and TextAttribute.WEIGHT_*. 
       Thanks to Glenn Adams.</description></item><item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        AFP GOCA: fonts were not embedded from within AFPGraphics2D.
      </description></item><item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        AFP GOCA: Changed the way FOP fonts are selected based on Batik's GVT fonts to match
        the behaviour of PDF/PS output.
      </description></item><item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added option to place AFP NOPs right before the end of a named page group (page-sequence),
        rather than after the start.
      </description></item><item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added option for PostScript output to optimize for file size rather than quality.
      </description></item><item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        AFP GOCA: Added option to disable GOCA and to control text painting inside GOCA graphics.
      </description></item><item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        AFP GOCA: Work-around for InfoPrint's AFP implementation which seems to lose
        the character set state over Graphics Data (GAD) boundaries.
      </description></item><item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Bugfix for AFP GOCA segments: they were not properly marked as appended which could
        lead to graphics state changes in some implementations.
      </description></item><item><title>Apache FOP Renderers fix
          (bug 51010)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 51010)
        
        :
        
        Bugzilla 51010: Bookmarks create useless lines in RTF 
       Thanks to Max Aster.</description></item><item><title>Apache FOP Renderers fix
          (bug 51008)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        CB
          (fixes bug 51008)
        
        :
        
        Bugzilla 51008: page-number-citation-last does not work in RTF
       Thanks to Max Aster.</description></item><item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        VH
        :
        
        Added id element to intermediate format to track the origin of content.
      </description></item><item><title>Apache FOP Renderers fix
          (bug 50987)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AD
          (fixes bug 50987)
        
        :
        
        Bugzilla 50988: Fixed a NullPointerException in case a white-space fo:character was removed
        due to white-space handling.
       Thanks to Matthias Reischenbacher.</description></item><item><title>Apache FOP Renderers fix
          (bug 50987)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AD
          (fixes bug 50987)
        
        :
        
        Bugzilla 50987: Fixed an issue in PDF output where a link was added to the parent tree 
        instead of the related structure element.
       Thanks to Martin Koegler.</description></item><item><title>Apache FOP Renderers fix
          (bug 50986)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        AD
          (fixes bug 50986)
        
        :
        
        Bugzilla 50986: Fixed an issue where invalid PDF page content was generated due to 
        incorrect ET/EMC sequences.
       Thanks to Martin Koegler.</description></item><item><title>Apache FOP Code fix
          (bug 50593)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 50593)
        
        :
        
        Fixed regression introduced by Bugzilla 50593: bookmarks pointing to a non-existing
        internal destination should just trigger a warning.
      </description></item><item><title>Apache FOP Layout fix
          (bug 50965)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 50965)
        
        :
        
        Bugzilla 50965: Fixed a regression in BlockContainerLayoutManager where margins were
        no longer reset after forced breaks.
       Thanks to Martin Koegler.</description></item><item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Implemented non-standard behavior for basic-link areas, such that they take into account the 
        heights of their descendants areas.
      </description></item><item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Fix for keep-together does not apply to fo:table-cell.
      </description></item><item><title>Apache FOP Layout fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
        :
        
        Fix for keep-together on a table containing row-spanning cells that was not honored.
      </description></item><item><title>Apache FOP Layout fix
          (bug 50196)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 50196)
        
        :
        
        Fix forpadding-start ignored when table-header/footer is repeated.
       Thanks to Matthias Reischenbacher.</description></item><item><title>Apache FOP Renderers fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
        :
        
        Increased maximum possible PDF size from 2GB to around 9GB (hard maximum imposed by the PDF specification).
      </description></item><item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Added support for CIE Lab colors (from XSL-FO 2.0 WD).
      </description></item><item><title>Apache FOP Renderers add
          (bug 49403)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 49403)
        
        :
        
        Initial work on spot colors (aka named colors) for PDF output.
       Thanks to Patrick Jaromin.</description></item><item><title>Apache FOP Renderers fix
          (bug 50705)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 50705)
        
        :
        
        Fix to preserve the order of AFP TLEs and NOPs as given in the XSL-FO document.
       Thanks to Mehdi Houshmand.</description></item><item><title>Apache FOP Fonts add
          (bug 50699)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        JM
          (fixes bug 50699)
        
        :
        
        Added support for lookup of alternative glyphs when additional single-byte encodings are
        used, ex. replacing "Omegagreek" by "Omega" and vice versa.
       Thanks to Alexandros Papadakis.</description></item><item><title>Apache FOP Code add
          (bug 48334)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code add
        by
        AD
          (fixes bug 48334)
        
        :
        
        Added support for resolution of relative URIs against a specified xml:base during
        property refinement.
      </description></item><item><title>Apache FOP Renderers add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
        :
        
        Allow afp:no-operation to also appear under fo:page-sequence and fo:declarations.
      </description></item><item><title>Apache FOP Code fix
          (bug 50635)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 50635)
        
        :
        
        Fix for issue in RenderPagesModel.checkPreparedPages() where the same page-sequence
        is potentially started multiple times.
       Thanks to Martin Koegler.</description></item><item><title>Apache FOP Code fix
          (bug 50636)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 50636)
        
        :
        
        Fix for performance issue when adding pages, if the total number of pages
        is significantly large.
       Thanks to Martin Koegler.</description></item><item><title>Apache FOP Code fix
          (bug 50626)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 50626)
        
        :
        
        Fix for performance issue when adding nodes, if the number of children
        is significantly large.
       Thanks to Martin Koegler.</description></item><item><title>Apache FOP Config fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Config fix
        by
        SP
        :
        
	Fix for relative URIs in the configuration file (base, font-base, hyphenation-base) are evaluated relative to the base URI of the configuration file.
      </description></item><item><title>Apache FOP Layout fix
          (bug 49848)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 49848)
        
        :
        
        Fix for correct behavior of keep-together.within-line in case there are nested inlines
      </description></item><item><title>Apache FOP Code fix
          (bug 50471)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        AD
          (fixes bug 50471)
        
        :
        
        Fix for avoid ArrayIndexOutOfBoundsException for codepoints without a linebreak class
      </description></item><item><title>Apache FOP Layout fix
          (bug 48380)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 48380)
        
        :
        
        Fix for avoid ClassCastException when using fox:widow-content-limit
      </description></item><item><title>Apache FOP Layout fix
          (bug 50089)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        VH
          (fixes bug 50089)
        
        :
        
        Fix for content after forced break in block-container is not rendered.
      </description></item><item><title>Apache FOP Layout fix
          (bug 42034)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 42034)
        
        :
        
        Fixed adjustment of inline parent area for justified text containing a forward page reference.
      </description></item><item><title>Apache FOP Layout fix
          (bug 38264)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        AD
          (fixes bug 38264)
        
        :
        
        Fixed behavior when combining hyphenation with preserved linefeeds or whitespace.
      </description></item><item><title>Apache FOP Code fix
          (bug 49695)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Code fix
        by
        VH
          (fixes bug 49695)
        
        :
        
        Replaced magic numbers with constants from UnitConv and GraphicsConstants.
       Thanks to Joshua Marquart.</description></item><item><title>Apache FOP Renderers add
          (bug 42600)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 42600)
        
        :
        
        Added some support for break-before/-after for RTF output.
       Thanks to Max Aster.</description></item><item><title>Apache FOP Renderers add
          (bug 49379)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 49379)
        
        :
        
        Added ability to embed an external AFP page segment resource file (AFP output only).
       Thanks to Peter Hancock.</description></item><item><title>Apache FOP Renderers fix
          (bug 46360)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers fix
        by
        JM
          (fixes bug 46360)
        
        :
        
        Fixed a multi-threading issue when rendering SVG.
       Thanks to Alexios Giotis.</description></item><item><title>Apache FOP Layout fix
          (bug 49885)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Layout fix
        by
        JM
          (fixes bug 49885)
        
        :
        
        Fixed retrieval of available BPD for cases spanning columns and multiple pages with differing page masters.
      </description></item><item><title>Apache FOP Renderers remove</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers remove
        by
        VH
        :
        
        Removed old Renderer implementations for those output formats that have a version based on 
        the new DocumentHandler architecture available (AFP, PCL, PDF, PS).
      </description></item><item><title>Apache FOP Fonts fix</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts fix
        by
        AC
        :
        
        Reinstated support for being able to specify a font cache filepath in the fop user configuration.
      </description></item><item><title>Apache FOP Fonts add</title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Fonts add
        by
        AC
        :
        
        Added convenience support for the flushing of the Fop font cache file from the command line.
      </description></item><item><title>Apache FOP Renderers add
          (bug 44460)
        </title><link>http://xmlgraphics.apache.org/fop//changes.html</link><description>Renderers add
        by
        JM
          (fixes bug 44460)
        
        :
        
        Added support for PDF File Attachments (Embedded Files).
       Thanks to Andrejus Chaliapinas.</description></item></channel></rss>